/**
 * enchant.js v0.8.3
 * http://enchantjs.com
 *
 * Copyright Ubiquitous Entertainment Inc.
 * Released under the MIT license.
 */
(function(f,c){if(typeof Object.defineProperty!=="function"){Object.defineProperty=function(l,n,m){if("value" in m){l[n]=m.value;}if("get" in m){l.__defineGetter__(n,m.get);
}if("set" in m){l.__defineSetter__(n,m.set);}return l;};}if(typeof Object.defineProperties!=="function"){Object.defineProperties=function(m,l){for(var n in l){if(l.hasOwnProperty(n)){Object.defineProperty(m,n,l[n]);
}}return m;};}if(typeof Object.create!=="function"){Object.create=function(l,n){function m(){}m.prototype=l;var o=new m();if(n!=null){Object.defineProperties(o,n);
}return o;};}if(typeof Object.getPrototypeOf!=="function"){Object.getPrototypeOf=function(l){return l.__proto__;};}if(typeof Function.prototype.bind!=="function"){Function.prototype.bind=function(l){var p=this;
var m=Array.prototype.slice.call(arguments,1);var o=function(){};var n=function(){var q=m.concat(Array.prototype.slice.call(arguments));return p.apply(this instanceof o?this:l||f,q);
};o.prototype=p.prototype;n.prototype=new o();return n;};}f.getTime=(function(){var l;if(f.performance&&f.performance.now){l=Date.now();return function(){return l+f.performance.now();
};}else{if(f.performance&&f.performance.webkitNow){l=Date.now();return function(){return l+f.performance.webkitNow();};}else{return Date.now;}}}());f.requestAnimationFrame=f.requestAnimationFrame||f.mozRequestAnimationFrame||f.webkitRequestAnimationFrame||f.msRequestAnimationFrame||(function(){var l=f.getTime();
var m=1000/60;return function(o){var n=setTimeout(function(){l=f.getTime();o(l);},Math.max(0,l+m-f.getTime()));return n;};}());var g=function(m){if(m!=null){if(!(m instanceof Array)){m=Array.prototype.slice.call(arguments);
}m=m.filter(function(n){return[n].join();});}(function l(q,r){var o=[],p,n;for(var s in q){if(q.hasOwnProperty(s)){if(typeof q[s]==="function"){f[s]=q[s];
}else{if(typeof q[s]==="object"&&q[s]!==null&&Object.getPrototypeOf(q[s])===Object.prototype){if(m==null){o.push(s);}else{p=m.indexOf(r+s);if(p!==-1){o.push(s);
m.splice(p,1);}}}}}}for(p=0,n=o.length;p<n;p++){l(q[o[p]],r+o[p]+".");}}(g,""));if(g.Class.getInheritanceTree(f.Game).length<=g.Class.getInheritanceTree(f.Core).length){f.Game=f.Core;
}if(m!=null&&m.length){throw new Error("Cannot load module: "+m.join(", "));}};f.enchant=g;f.addEventListener("message",function(o,l){try{var m=JSON.parse(o.data);
if(m.type==="event"){g.Core.instance.dispatchEvent(new g.Event(m.value));}else{if(m.type==="debug"){switch(m.value){case"start":g.Core.instance.start();
break;case"pause":g.Core.instance.pause();break;case"resume":g.Core.instance.resume();break;case"tick":g.Core.instance._tick();break;default:break;}}}}catch(n){}},false);
g.Class=function(m,l){return g.Class.create(m,l);};g.Class.create=function(s,p){if(s==null&&p){throw new Error("superclass is undefined (enchant.Class.create)");
}else{if(s==null){throw new Error("definition is undefined (enchant.Class.create)");}}if(arguments.length===0){return g.Class.create(Object,p);}else{if(arguments.length===1&&typeof arguments[0]!=="function"){return g.Class.create(Object,arguments[0]);
}}for(var r in p){if(p.hasOwnProperty(r)){if(typeof p[r]==="object"&&p[r]!==null&&Object.getPrototypeOf(p[r])===Object.prototype){if(!("enumerable" in p[r])){p[r].enumerable=true;
}}else{p[r]={value:p[r],enumerable:true,writable:true};}}}var q=function(){if(this instanceof q){q.prototype.initialize.apply(this,arguments);}else{return new q();
}};q.prototype=Object.create(s.prototype,p);q.prototype.constructor=q;if(q.prototype.initialize==null){q.prototype.initialize=function(){s.apply(this,arguments);
};}var m=this.getInheritanceTree(s);for(var o=0,n=m.length;o<n;o++){if(typeof m[o]._inherited==="function"){m[o]._inherited(q);break;}}return q;};g.Class.getInheritanceTree=function(o){var l=[];
var n=o;var m=n.prototype;while(n!==Object){l.push(n);m=Object.getPrototypeOf(m);n=m.constructor;}return l;};g.ENV={VERSION:"0.8.3",BROWSER:(function(l){if(/Eagle/.test(l)){return"eagle";
}else{if(/Opera/.test(l)){return"opera";}else{if(/MSIE|Trident/.test(l)){return"ie";}else{if(/Chrome/.test(l)){return"chrome";}else{if(/(?:Macintosh|Windows).*AppleWebKit/.test(l)){return"safari";
}else{if(/(?:iPhone|iPad|iPod).*AppleWebKit/.test(l)){return"mobilesafari";}else{if(/Firefox/.test(l)){return"firefox";}else{if(/Android/.test(l)){return"android";
}else{return"";}}}}}}}}}(navigator.userAgent)),VENDOR_PREFIX:(function(){var l=navigator.userAgent;if(l.indexOf("Opera")!==-1){return"O";}else{if(/MSIE|Trident/.test(l)){return"ms";
}else{if(l.indexOf("WebKit")!==-1){return"webkit";}else{if(navigator.product==="Gecko"){return"Moz";}else{return"";}}}}}()),TOUCH_ENABLED:(function(){var l=document.createElement("div");
l.setAttribute("ontouchstart","return");return typeof l.ontouchstart==="function";}()),RETINA_DISPLAY:(function(){if(navigator.userAgent.indexOf("iPhone")!==-1&&f.devicePixelRatio===2){var l=document.querySelector('meta[name="viewport"]');
if(l==null){l=document.createElement("meta");document.head.appendChild(l);}l.setAttribute("content","width=640");return true;}else{return false;}}()),USE_FLASH_SOUND:(function(){var l=navigator.userAgent;
var m=navigator.vendor||"";return(location.href.indexOf("http")===0&&l.indexOf("Mobile")===-1&&m.indexOf("Apple")!==-1);}()),USE_DEFAULT_EVENT_TAGS:["input","textarea","select","area"],CANVAS_DRAWING_METHODS:["putImageData","drawImage","drawFocusRing","fill","stroke","clearRect","fillRect","strokeRect","fillText","strokeText"],KEY_BIND_TABLE:{37:"left",38:"up",39:"right",40:"down"},PREVENT_DEFAULT_KEY_CODES:[37,38,39,40],SOUND_ENABLED_ON_MOBILE_SAFARI:true,USE_TOUCH_TO_START_SCENE:true,USE_WEBAUDIO:(function(){return location.protocol!=="file:";
}()),USE_ANIMATION:true,COLOR_DETECTION_LEVEL:2};g.Event=g.Class.create({initialize:function(l){this.type=l;this.target=null;this.x=0;this.y=0;this.localX=0;
this.localY=0;},_initPosition:function(n,m){var l=g.Core.instance;this.x=this.localX=(n-l._pageX)/l.scale;this.y=this.localY=(m-l._pageY)/l.scale;}});g.Event.LOAD="load";
g.Event.ERROR="error";g.Event.CORE_RESIZE="coreresize";g.Event.PROGRESS="progress";g.Event.ENTER_FRAME="enterframe";g.Event.EXIT_FRAME="exitframe";g.Event.ENTER="enter";
g.Event.EXIT="exit";g.Event.CHILD_ADDED="childadded";g.Event.ADDED="added";g.Event.ADDED_TO_SCENE="addedtoscene";g.Event.CHILD_REMOVED="childremoved";g.Event.REMOVED="removed";
g.Event.REMOVED_FROM_SCENE="removedfromscene";g.Event.TOUCH_START="touchstart";g.Event.TOUCH_MOVE="touchmove";g.Event.TOUCH_END="touchend";g.Event.RENDER="render";
g.Event.INPUT_START="inputstart";g.Event.INPUT_CHANGE="inputchange";g.Event.INPUT_END="inputend";g.Event.INPUT_STATE_CHANGED="inputstatechanged";g.Event.LEFT_BUTTON_DOWN="leftbuttondown";
g.Event.LEFT_BUTTON_UP="leftbuttonup";g.Event.RIGHT_BUTTON_DOWN="rightbuttondown";g.Event.RIGHT_BUTTON_UP="rightbuttonup";g.Event.UP_BUTTON_DOWN="upbuttondown";
g.Event.UP_BUTTON_UP="upbuttonup";g.Event.DOWN_BUTTON_DOWN="downbuttondown";g.Event.DOWN_BUTTON_UP="downbuttonup";g.Event.A_BUTTON_DOWN="abuttondown";g.Event.A_BUTTON_UP="abuttonup";
g.Event.B_BUTTON_DOWN="bbuttondown";g.Event.B_BUTTON_UP="bbuttonup";g.Event.ADDED_TO_TIMELINE="addedtotimeline";g.Event.REMOVED_FROM_TIMELINE="removedfromtimeline";
g.Event.ACTION_START="actionstart";g.Event.ACTION_END="actionend";g.Event.ACTION_TICK="actiontick";g.Event.ACTION_ADDED="actionadded";g.Event.ACTION_REMOVED="actionremoved";
g.Event.ANIMATION_END="animationend";g.EventTarget=g.Class.create({initialize:function(){this._listeners={};},addEventListener:function(m,n){var l=this._listeners[m];
if(l==null){this._listeners[m]=[n];}else{if(l.indexOf(n)===-1){l.unshift(n);}}},on:function(){this.addEventListener.apply(this,arguments);},removeEventListener:function(n,o){var m=this._listeners[n];
if(m!=null){var l=m.indexOf(o);if(l!==-1){m.splice(l,1);}}},clearEventListener:function(l){if(l!=null){delete this._listeners[l];}else{this._listeners={};
}},dispatchEvent:function(o){o.target=this;o.localX=o.x-this._offsetX;o.localY=o.y-this._offsetY;if(this["on"+o.type]!=null){this["on"+o.type](o);}var n=this._listeners[o.type];
if(n!=null){n=n.slice();for(var m=0,l=n.length;m<l;m++){n[m].call(this,o);}}}});(function(){var l;g.Core=g.Class.create(g.EventTarget,{initialize:function(p,y){if(f.document.body===null){throw new Error("document.body is null. Please excute 'new Core()' in window.onload.");
}g.EventTarget.call(this);var v=true;if(l){v=false;l.stop();}l=g.Core.instance=this;this._calledTime=0;this._mousedownID=0;this._surfaceID=0;this._soundID=0;
this._scenes=[];p=p||320;y=y||320;var w=document.getElementById("enchant-stage");var s,q,u;if(!w){w=document.createElement("div");w.id="enchant-stage";
w.style.position="absolute";if(document.body.firstChild){document.body.insertBefore(w,document.body.firstChild);}else{document.body.appendChild(w);}s=Math.min(f.innerWidth/p,f.innerHeight/y);
this._pageX=w.getBoundingClientRect().left;this._pageY=w.getBoundingClientRect().top;}else{var o=f.getComputedStyle(w);q=parseInt(o.width,10);u=parseInt(o.height,10);
if(q&&u){s=Math.min(q/p,u/y);}else{s=1;}while(w.firstChild){w.removeChild(w.firstChild);}w.style.position="relative";var n=w.getBoundingClientRect();this._pageX=Math.round(f.scrollX||f.pageXOffset+n.left);
this._pageY=Math.round(f.scrollY||f.pageYOffset+n.top);}w.style.fontSize="12px";w.style.webkitTextSizeAdjust="none";w.style.webkitTapHighlightColor="rgba(0, 0, 0, 0)";
this._element=w;this.addEventListener("coreresize",this._oncoreresize);this._width=p;this._height=y;this.scale=s;this.fps=30;this.frame=0;this.ready=false;
this.running=false;this.assets={};var t=this._assets=[];(function r(z){if(z.assets){g.Core.instance.preload(z.assets);}for(var A in z){if(z.hasOwnProperty(A)){if(typeof z[A]==="object"&&z[A]!==null&&Object.getPrototypeOf(z[A])===Object.prototype){r(z[A]);
}}}}(g));this.currentScene=null;this.rootScene=new g.Scene();this.pushScene(this.rootScene);this.loadingScene=new g.LoadingScene();this._activated=false;
this._offsetX=0;this._offsetY=0;this.input={};this.keyboardInputManager=new g.KeyboardInputManager(f.document,this.input);this.keyboardInputManager.addBroadcastTarget(this);
this._keybind=this.keyboardInputManager._binds;if(!g.ENV.KEY_BIND_TABLE){g.ENV.KEY_BIND_TABLE={};}for(var m in g.ENV.KEY_BIND_TABLE){this.keybind(m,g.ENV.KEY_BIND_TABLE[m]);
}if(v){w=g.Core.instance._element;var x;document.addEventListener("keydown",function(z){l.dispatchEvent(new g.Event("keydown"));if(g.ENV.PREVENT_DEFAULT_KEY_CODES.indexOf(z.keyCode)!==-1){z.preventDefault();
z.stopPropagation();}},true);if(g.ENV.TOUCH_ENABLED){w.addEventListener("touchstart",function(A){var z=(A.target.tagName).toLowerCase();if(g.ENV.USE_DEFAULT_EVENT_TAGS.indexOf(z)===-1){A.preventDefault();
if(!l.running){A.stopPropagation();}}},true);w.addEventListener("touchmove",function(A){var z=(A.target.tagName).toLowerCase();if(g.ENV.USE_DEFAULT_EVENT_TAGS.indexOf(z)===-1){A.preventDefault();
if(!l.running){A.stopPropagation();}}},true);w.addEventListener("touchend",function(A){var z=(A.target.tagName).toLowerCase();if(g.ENV.USE_DEFAULT_EVENT_TAGS.indexOf(z)===-1){A.preventDefault();
if(!l.running){A.stopPropagation();}}},true);}w.addEventListener("mousedown",function(A){var z=(A.target.tagName).toLowerCase();if(g.ENV.USE_DEFAULT_EVENT_TAGS.indexOf(z)===-1){A.preventDefault();
l._mousedownID++;if(!l.running){A.stopPropagation();}}},true);w.addEventListener("mousemove",function(A){var z=(A.target.tagName).toLowerCase();if(g.ENV.USE_DEFAULT_EVENT_TAGS.indexOf(z)===-1){A.preventDefault();
if(!l.running){A.stopPropagation();}}},true);w.addEventListener("mouseup",function(A){var z=(A.target.tagName).toLowerCase();if(g.ENV.USE_DEFAULT_EVENT_TAGS.indexOf(z)===-1){A.preventDefault();
if(!l.running){A.stopPropagation();}}},true);l._touchEventTarget={};if(g.ENV.TOUCH_ENABLED){w.addEventListener("touchstart",function(F){var B=g.Core.instance;
var A=new g.Event(g.Event.TOUCH_START);var E=F.changedTouches;var G,D;for(var C=0,z=E.length;C<z;C++){G=E[C];A._initPosition(G.pageX,G.pageY);D=B.currentScene._determineEventTarget(A);
B._touchEventTarget[G.identifier]=D;D.dispatchEvent(A);}},false);w.addEventListener("touchmove",function(F){var B=g.Core.instance;var A=new g.Event(g.Event.TOUCH_MOVE);
var E=F.changedTouches;var G,D;for(var C=0,z=E.length;C<z;C++){G=E[C];D=B._touchEventTarget[G.identifier];if(D){A._initPosition(G.pageX,G.pageY);D.dispatchEvent(A);
}}},false);w.addEventListener("touchend",function(F){var B=g.Core.instance;var A=new g.Event(g.Event.TOUCH_END);var E=F.changedTouches;var G,D;for(var C=0,z=E.length;
C<z;C++){G=E[C];D=B._touchEventTarget[G.identifier];if(D){A._initPosition(G.pageX,G.pageY);D.dispatchEvent(A);delete B._touchEventTarget[G.identifier];
}}},false);}w.addEventListener("mousedown",function(C){var A=g.Core.instance;var z=new g.Event(g.Event.TOUCH_START);z._initPosition(C.pageX,C.pageY);var B=A.currentScene._determineEventTarget(z);
A._touchEventTarget[A._mousedownID]=B;B.dispatchEvent(z);},false);w.addEventListener("mousemove",function(C){var A=g.Core.instance;var z=new g.Event(g.Event.TOUCH_MOVE);
z._initPosition(C.pageX,C.pageY);var B=A._touchEventTarget[A._mousedownID];if(B){B.dispatchEvent(z);}},false);w.addEventListener("mouseup",function(C){var A=g.Core.instance;
var z=new g.Event(g.Event.TOUCH_END);z._initPosition(C.pageX,C.pageY);var B=A._touchEventTarget[A._mousedownID];if(B){B.dispatchEvent(z);}delete A._touchEventTarget[A._mousedownID];
},false);}},width:{get:function(){return this._width;},set:function(m){this._width=m;this._dispatchCoreResizeEvent();}},height:{get:function(){return this._height;
},set:function(m){this._height=m;this._dispatchCoreResizeEvent();}},scale:{get:function(){return this._scale;},set:function(m){this._scale=m;this._dispatchCoreResizeEvent();
}},_dispatchCoreResizeEvent:function(){var m=new g.Event("coreresize");m.width=this._width;m.height=this._height;m.scale=this._scale;this.dispatchEvent(m);
},_oncoreresize:function(p){this._element.style.width=Math.floor(this._width*this._scale)+"px";this._element.style.height=Math.floor(this._height*this._scale)+"px";
var o;for(var n=0,m=this._scenes.length;n<m;n++){o=this._scenes[n];o.dispatchEvent(p);}},preload:function(o){var m;if(!(o instanceof Array)){if(typeof o==="object"){m=[];
for(var n in o){if(o.hasOwnProperty(n)){m.push([o[n],n]);}}o=m;}else{o=Array.prototype.slice.call(arguments);}}Array.prototype.push.apply(this._assets,o);
return this;},load:function(r,o,s,m){var q;if(typeof arguments[1]==="string"){q=o;s=s||function(){};m=m||function(){};}else{q=r;var n=s;s=arguments[1]||function(){};
m=n||function(){};}var p=g.Core.findExt(r);return g.Deferred.next(function(){var w=new g.Deferred();var t=function(x){w.call(x);s.call(this,x);};var v=function(x){w.fail(x);
m.call(this,x);};if(g.Core._loadFuncs[p]){g.Core.instance.assets[q]=g.Core._loadFuncs[p](r,p,t,v);}else{var u=new XMLHttpRequest();u.open("GET",r,true);
u.onreadystatechange=function(){if(u.readyState===4){if(u.status!==200&&u.status!==0){var y=new g.Event("error");y.message=u.status+": Cannot load an asset: "+r;
v.call(g.Core.instance,y);}var x=u.getResponseHeader("Content-Type")||"";if(x.match(/^image/)){l.assets[q]=g.Surface.load(r,t,v);}else{if(x.match(/^audio/)){l.assets[q]=g.Sound.load(r,x,t,v);
}else{l.assets[q]=u.responseText;t.call(g.Core.instance,new g.Event("load"));}}}};u.send(null);}return w;});},start:function(m){var p=function(){this.frame=0;
this.removeEventListener("load",p);};this.addEventListener("load",p);this.currentTime=f.getTime();this.running=true;this.ready=true;if(!this._activated){this._activated=true;
if(g.ENV.BROWSER==="mobilesafari"&&g.ENV.USE_WEBAUDIO&&g.ENV.USE_TOUCH_TO_START_SCENE){var r=new g.Deferred();var q=this._createTouchToStartScene();q.addEventListener(g.Event.TOUCH_START,function o(){this.removeEventListener(g.Event.TOUCH_START,o);
var s=new g.WebAudioSound();s.buffer=g.WebAudioSound.audioContext.createBuffer(1,1,48000);s.play();l.removeScene(q);l.start(r);},false);l.pushScene(q);
return r;}}this._requestNextFrame(0);var n=this._requestPreload().next(function(){g.Core.instance.loadingScene.dispatchEvent(new g.Event(g.Event.LOAD));
});if(m){n.next(function(s){m.call(s);}).error(function(s){m.fail(s);});}return n;},_requestPreload:function(){var p={};var n=0,m=0,q=function(){var o=new g.Event("progress");
o.loaded=++n;o.total=m;l.loadingScene.dispatchEvent(o);};this._assets.reverse().forEach(function(r){var s,o;if(r instanceof Array){s=r[0];o=r[1];}else{s=o=r;
}if(!p[o]){p[o]=this.load(s,o,q);m++;}},this);this.pushScene(this.loadingScene);return g.Deferred.parallel(p);},_createTouchToStartScene:function(){var m=new g.Label("Touch to Start"),n=Math.round(l.width/10),o=new g.Scene();
m.color="#fff";m.font=(n-1)+"px bold Helvetica,Arial,sans-serif";m.textAlign="center";m.width=l.width;m.height=m._boundHeight;m.y=(l.height-m.height)/2;
o.backgroundColor="#000";o.addChild(m);return o;},debug:function(){this._debug=true;return this.start();},actualFps:{get:function(){return this._actualFps||this.fps;
}},_requestNextFrame:function(m){if(!this.ready){return;}if(this.fps>=60||m<=16){this._calledTime=f.getTime();f.requestAnimationFrame(this._callTick);}else{setTimeout(function(){var n=g.Core.instance;
n._calledTime=f.getTime();f.requestAnimationFrame(n._callTick);},Math.max(0,m));}},_callTick:function(m){g.Core.instance._tick(m);},_tick:function(s){var r=new g.Event("enterframe");
var p=f.getTime();var m=r.elapsed=p-this.currentTime;this.currentTime=p;this._actualFps=m>0?(1000/m):0;var n=this.currentScene.childNodes.slice();var o=Array.prototype.push;
while(n.length){var q=n.pop();q.age++;q.dispatchEvent(r);if(q.childNodes){o.apply(n,q.childNodes);}}this.currentScene.age++;this.currentScene.dispatchEvent(r);
this.dispatchEvent(r);this.dispatchEvent(new g.Event("exitframe"));this.frame++;p=f.getTime();this._requestNextFrame(1000/this.fps-(p-this._calledTime));
},getTime:function(){return f.getTime();},stop:function(){this.ready=false;this.running=false;},pause:function(){this.ready=false;},resume:function(){if(this.ready){return;
}this.currentTime=f.getTime();this.ready=true;this.running=true;this._requestNextFrame(0);},pushScene:function(m){this._element.appendChild(m._element);
if(this.currentScene){this.currentScene.dispatchEvent(new g.Event("exit"));}this.currentScene=m;this.currentScene.dispatchEvent(new g.Event("enter"));return this._scenes.push(m);
},popScene:function(){if(this.currentScene===this.rootScene){return this.currentScene;}this._element.removeChild(this.currentScene._element);this.currentScene.dispatchEvent(new g.Event("exit"));
this.currentScene=this._scenes[this._scenes.length-2];this.currentScene.dispatchEvent(new g.Event("enter"));return this._scenes.pop();},replaceScene:function(m){this.popScene();
return this.pushScene(m);},removeScene:function(n){if(this.currentScene===n){return this.popScene();}else{var m=this._scenes.indexOf(n);if(m!==-1){this._scenes.splice(m,1);
this._element.removeChild(n._element);return n;}else{return null;}}},_buttonListener:function(m){this.currentScene.dispatchEvent(m);},keybind:function(n,m){this.keyboardInputManager.keybind(n,m);
this.addEventListener(m+"buttondown",this._buttonListener);this.addEventListener(m+"buttonup",this._buttonListener);return this;},keyunbind:function(n){var m=this._keybind[n];
this.keyboardInputManager.keyunbind(n);this.removeEventListener(m+"buttondown",this._buttonListener);this.removeEventListener(m+"buttonup",this._buttonListener);
return this;},changeButtonState:function(n,m){this.keyboardInputManager.changeState(n,m);},getElapsedTime:function(){return this.frame/this.fps;}});g.Core._loadFuncs={};
g.Core._loadFuncs.jpg=g.Core._loadFuncs.jpeg=g.Core._loadFuncs.gif=g.Core._loadFuncs.png=g.Core._loadFuncs.bmp=function(o,n,p,m){return g.Surface.load(o,p,m);
};g.Core._loadFuncs.mp3=g.Core._loadFuncs.aac=g.Core._loadFuncs.m4a=g.Core._loadFuncs.wav=g.Core._loadFuncs.ogg=function(o,n,p,m){return g.Sound.load(o,"audio/"+n,p,m);
};g.Core.findExt=function(n){var m=n.match(/\.\w+$/);if(m&&m.length>0){return m[0].slice(1).toLowerCase();}if(n.indexOf("data:")===0){return n.split(/[\/;]/)[1].toLowerCase();
}return null;};g.Core.instance=null;}());g.Game=g.Core;g.InputManager=g.Class.create(g.EventTarget,{initialize:function(m,l){g.EventTarget.call(this);this.broadcastTarget=[];
this.valueStore=m;this.source=l||this;this._binds={};this._stateHandler=function(o){var p=o.source.identifier;var n=this._binds[p];this.changeState(n,o.data);
}.bind(this);},bind:function(l,m){l.addEventListener(g.Event.INPUT_STATE_CHANGED,this._stateHandler);this._binds[l.identifier]=m;},unbind:function(l){l.removeEventListener(g.Event.INPUT_STATE_CHANGED,this._stateHandler);
delete this._binds[l.identifier];},addBroadcastTarget:function(m){var l=this.broadcastTarget.indexOf(m);if(l===-1){this.broadcastTarget.push(m);}},removeBroadcastTarget:function(m){var l=this.broadcastTarget.indexOf(m);
if(l!==-1){this.broadcastTarget.splice(l,1);}},broadcastEvent:function(p){var o=this.broadcastTarget;for(var n=0,m=o.length;n<m;n++){o[n].dispatchEvent(p);
}},changeState:function(l,m){}});g.InputSource=g.Class.create(g.EventTarget,{initialize:function(l){g.EventTarget.call(this);this.identifier=l;},notifyStateChange:function(l){var m=new g.Event(g.Event.INPUT_STATE_CHANGED);
m.data=l;m.source=this;this.dispatchEvent(m);}});g.BinaryInputManager=g.Class.create(g.InputManager,{initialize:function(n,m,l,o){g.InputManager.call(this,n,o);
this.activeInputsNum=0;this.activeEventNameSuffix=m;this.inactiveEventNameSuffix=l;},bind:function(m,l){g.InputManager.prototype.bind.call(this,m,l);this.valueStore[l]=false;
},unbind:function(m){var l=this._binds[m.identifier];g.InputManager.prototype.unbind.call(this,m);delete this.valueStore[l];},changeState:function(m,l){if(l){this._down(m);
}else{this._up(m);}},_down:function(l){var n;if(!this.valueStore[l]){this.valueStore[l]=true;n=new g.Event((this.activeInputsNum++)?"inputchange":"inputstart");
n.source=this.source;this.broadcastEvent(n);}var m=new g.Event(l+this.activeEventNameSuffix);m.source=this.source;this.broadcastEvent(m);},_up:function(m){var n;
if(this.valueStore[m]){this.valueStore[m]=false;n=new g.Event((--this.activeInputsNum)?"inputchange":"inputend");n.source=this.source;this.broadcastEvent(n);
}var l=new g.Event(m+this.inactiveEventNameSuffix);l.source=this.source;this.broadcastEvent(l);}});g.BinaryInputSource=g.Class.create(g.InputSource,{initialize:function(l){g.InputSource.call(this,l);
}});g.KeyboardInputManager=g.Class.create(g.BinaryInputManager,{initialize:function(m,l){g.BinaryInputManager.call(this,l,"buttondown","buttonup");this._attachDOMEvent(m,"keydown",true);
this._attachDOMEvent(m,"keyup",false);},keybind:function(m,l){this.bind(g.KeyboardInputSource.getByKeyCode(""+m),l);},keyunbind:function(l){this.unbind(g.KeyboardInputSource.getByKeyCode(""+l));
},_attachDOMEvent:function(n,l,m){n.addEventListener(l,function(r){var o=g.Core.instance;if(!o||!o.running){return;}var p=r.keyCode;var q=g.KeyboardInputSource._instances[p];
if(q){q.notifyStateChange(m);}},true);}});g.KeyboardInputSource=g.Class.create(g.BinaryInputSource,{initialize:function(l){g.BinaryInputSource.call(this,l);
}});g.KeyboardInputSource._instances={};g.KeyboardInputSource.getByKeyCode=function(l){if(!this._instances[l]){this._instances[l]=new g.KeyboardInputSource(l);
}return this._instances[l];};g.Node=g.Class.create(g.EventTarget,{initialize:function(){g.EventTarget.call(this);this._dirty=false;this._matrix=[1,0,0,1,0,0];
this._x=0;this._y=0;this._offsetX=0;this._offsetY=0;this.age=0;this.parentNode=null;this.scene=null;this.addEventListener("touchstart",function(l){if(this.parentNode){this.parentNode.dispatchEvent(l);
}});this.addEventListener("touchmove",function(l){if(this.parentNode){this.parentNode.dispatchEvent(l);}});this.addEventListener("touchend",function(l){if(this.parentNode){this.parentNode.dispatchEvent(l);
}});if(g.ENV.USE_ANIMATION){this.tl=new g.Timeline(this);}},moveTo:function(l,m){this.x=l;this.y=m;},moveBy:function(l,m){this.x+=l;this.y+=m;},x:{get:function(){return this._x;
},set:function(l){if(this._x!==l){this._x=l;this._dirty=true;}}},y:{get:function(){return this._y;},set:function(l){if(this._y!==l){this._y=l;this._dirty=true;
}}},_updateCoordinate:function(){var p=this;var y=[p];var v=p.parentNode;var s=this.scene;while(v&&p._dirty){y.unshift(v);p=p.parentNode;v=p.parentNode;
}var u=g.Matrix.instance;var t=u.stack;var x=[];var w,n,m;t.push(y[0]._matrix);for(var r=1,q=y.length;r<q;r++){p=y[r];w=[];u.makeTransformMatrix(p,x);u.multiply(t[t.length-1],x,w);
p._matrix=w;t.push(w);n=(typeof p._originX==="number")?p._originX:p._width/2||0;m=(typeof p._originY==="number")?p._originY:p._height/2||0;var o=[n,m];
u.multiplyVec(w,o,o);p._offsetX=o[0]-n;p._offsetY=o[1]-m;p._dirty=false;}u.reset();},remove:function(){if(this.parentNode){this.parentNode.removeChild(this);
}if(this.childNodes){var m=this.childNodes.slice();for(var l=m.length-1;l>=0;l--){m[l].remove();}}this.clearEventListener();}});var i=function(o,m){var p=[];
var r;for(var q=0,n=o.collection.length;q<n;q++){r=o.collection[q];if(m._intersectOne(r)){p.push(r);}}return p;};var k=function(s,r){var t=[];var p,n;for(var q=0,m=s.collection.length;
q<m;q++){p=s.collection[q];for(var o=0,u=r.collection.length;o<u;o++){n=r.collection[o];if(p._intersectOne(n)){t.push([p,n]);}}}return t;};var e=function(o,m){var p=[];
var r;for(var q=0,n=o.collection.length;q<n;q++){r=o.collection[q];if(m._intersectStrictOne(r)){p.push(r);}}return p;};var h=function(s,r){var t=[];var p,n;
for(var q=0,m=s.collection.length;q<m;q++){p=s.collection[q];for(var o=0,u=r.collection.length;o<u;o++){n=r.collection[o];if(p._intersectStrictOne(n)){t.push([p,n]);
}}}return t;};var d=function(l){if(l instanceof g.Entity){return i(this,l);}else{if(typeof l==="function"&&l.collection){return k(this,l);}}return false;
};var a=function(l){if(l instanceof g.Entity){return e(this,l);}else{if(typeof l==="function"&&l.collection){return h(this,l);}}return false;};var j=g.Node.prototype.clearEventListener;
g.Entity=g.Class.create(g.Node,{initialize:function(){var l=g.Core.instance;g.Node.call(this);this._rotation=0;this._scaleX=1;this._scaleY=1;this._touchEnabled=true;
this._clipping=false;this._originX=null;this._originY=null;this._width=0;this._height=0;this._backgroundColor=null;this._debugColor="#0000ff";this._opacity=1;
this._visible=true;this._buttonMode=null;this._style={};this.__styleStatus={};this._isContainedInCollection=false;this.compositeOperation=null;this.buttonMode=null;
this.buttonPressed=false;this.addEventListener("touchstart",function(){if(!this.buttonMode){return;}this.buttonPressed=true;this.dispatchEvent(new g.Event(this.buttonMode+"buttondown"));
l.changeButtonState(this.buttonMode,true);});this.addEventListener("touchend",function(){if(!this.buttonMode){return;}this.buttonPressed=false;this.dispatchEvent(new g.Event(this.buttonMode+"buttonup"));
l.changeButtonState(this.buttonMode,false);});this.enableCollection();},width:{get:function(){return this._width;},set:function(l){if(this._width!==l){this._width=l;
this._dirty=true;}}},height:{get:function(){return this._height;},set:function(l){if(this._height!==l){this._height=l;this._dirty=true;}}},backgroundColor:{get:function(){return this._backgroundColor;
},set:function(l){this._backgroundColor=l;}},debugColor:{get:function(){return this._debugColor;},set:function(l){this._debugColor=l;}},opacity:{get:function(){return this._opacity;
},set:function(l){this._opacity=parseFloat(l);}},visible:{get:function(){return this._visible;},set:function(l){this._visible=l;}},touchEnabled:{get:function(){return this._touchEnabled;
},set:function(l){this._touchEnabled=l;if(l){this._style.pointerEvents="all";}else{this._style.pointerEvents="none";}}},intersect:function(l){if(l instanceof g.Entity){return this._intersectOne(l);
}else{if(typeof l==="function"&&l.collection){return i(l,this);}}return false;},_intersectOne:function(l){if(this._dirty){this._updateCoordinate();}if(l._dirty){l._updateCoordinate();
}return this._offsetX<l._offsetX+l.width&&l._offsetX<this._offsetX+this.width&&this._offsetY<l._offsetY+l.height&&l._offsetY<this._offsetY+this.height;
},intersectStrict:function(l){if(l instanceof g.Entity){return this._intersectStrictOne(l);}else{if(typeof l==="function"&&l.collection){return e(l,this);
}}return false;},_intersectStrictOne:function(n){if(this._dirty){this._updateCoordinate();}if(n._dirty){n._updateCoordinate();}var Q=this.getOrientedBoundingRect(),O=n.getOrientedBoundingRect(),r=Q.leftTop,R=Q.rightTop,av=Q.leftBottom,F=Q.rightBottom,q=O.leftTop,P=O.rightTop,au=O.leftBottom,E=O.rightBottom,A=r[0],ap=r[1],af=R[0],L=R[1],H=av[0],at=av[1],aj=F[0],T=F[1],x=q[0],ao=q[1],ae=P[0],K=P[1],G=au[0],ar=au[1],ai=E[0],S=E[1],ad=[af-A,L-ap],D=[aj-af,T-L],X=[H-aj,at-T],B=[A-H,ap-at],ac=[ae-x,K-ao],C=[ai-ae,S-K],W=[G-ai,ar-S],z=[x-G,ao-ar],al=(A+af+H+aj)>>2,Z=(ap+L+at+T)>>2,ak=(x+ae+G+ai)>>2,Y=(ao+K+ar+S)>>2,an,am,ab,aa,V,U,p,o,v,t,J,m,I,l,ah,N,ag,M,y,w,aq,u,s;
if(ad[0]*(Y-ap)-ad[1]*(ak-A)>0&&D[0]*(Y-L)-D[1]*(ak-af)>0&&X[0]*(Y-T)-X[1]*(ak-aj)>0&&B[0]*(Y-at)-B[1]*(ak-H)>0){return true;}else{if(ac[0]*(Z-ao)-ac[1]*(al-x)>0&&C[0]*(Z-K)-C[1]*(al-ae)>0&&W[0]*(Z-S)-W[1]*(al-ai)>0&&z[0]*(Z-ar)-z[1]*(al-G)>0){return true;
}else{ab=[r,R,F,av];aa=[q,P,E,au];V=[ad,D,X,B];U=[ac,C,W,z];for(an=0;an<4;an++){p=ab[an];J=p[0];m=p[1];v=V[an];ah=v[0];N=v[1];for(am=0;am<4;am++){o=aa[am];
I=o[0];l=o[1];t=U[am];ag=t[0];M=t[1];aq=ah*M-N*ag;if(aq!==0){y=I-J;w=l-m;u=(y*N-w*ah)/aq;s=(y*M-w*ag)/aq;if(0<u&&u<1&&0<s&&s<1){return true;}}}}return false;
}}},within:function(l,n){if(this._dirty){this._updateCoordinate();}if(l._dirty){l._updateCoordinate();}if(n==null){n=(this.width+this.height+l.width+l.height)/4;
}var m;return(m=this._offsetX-l._offsetX+(this.width-l.width)/2)*m+(m=this._offsetY-l._offsetY+(this.height-l.height)/2)*m<n*n;},scale:function(l,m){this._scaleX*=l;
this._scaleY*=(m!=null)?m:l;this._dirty=true;},rotate:function(l){this.rotation+=l;},scaleX:{get:function(){return this._scaleX;},set:function(l){if(this._scaleX!==l){this._scaleX=l;
this._dirty=true;}}},scaleY:{get:function(){return this._scaleY;},set:function(l){if(this._scaleY!==l){this._scaleY=l;this._dirty=true;}}},rotation:{get:function(){return this._rotation;
},set:function(l){if(this._rotation!==l){this._rotation=l;this._dirty=true;}}},originX:{get:function(){return this._originX;},set:function(l){if(this._originX!==l){this._originX=l;
this._dirty=true;}}},originY:{get:function(){return this._originY;},set:function(l){if(this._originY!==l){this._originY=l;this._dirty=true;}}},enableCollection:function(){this.addEventListener("addedtoscene",this._addSelfToCollection);
this.addEventListener("removedfromscene",this._removeSelfFromCollection);if(this.scene){this._addSelfToCollection();}},disableCollection:function(){this.removeEventListener("addedtoscene",this._addSelfToCollection);
this.removeEventListener("removedfromscene",this._removeSelfFromCollection);if(this.scene){this._removeSelfFromCollection();}},clearEventListener:function(){j.apply(this,arguments);
if(this.scene){this._removeSelfFromCollection();}},_addSelfToCollection:function(){if(this._isContainedInCollection){return;}var l=this.getConstructor();
l._collectionTarget.forEach(function(m){m.collection.push(this);},this);this._isContainedInCollection=true;},_removeSelfFromCollection:function(){if(!this._isContainedInCollection){return;
}var l=this.getConstructor();l._collectionTarget.forEach(function(n){var m=n.collection.indexOf(this);if(m!==-1){n.collection.splice(m,1);}},this);this._isContainedInCollection=false;
},getBoundingRect:function(){var s=this.width||0;var n=this.height||0;var u=this._matrix;var v=u[0]*s,q=u[1]*s,t=u[2]*n,o=u[3]*n,r=u[4],p=u[5];var l=[r,v+r,t+r,v+t+r].sort(function(x,w){return x-w;
});var m=[p,q+p,o+p,q+o+p].sort(function(x,w){return x-w;});return{left:l[0],top:m[0],width:l[3]-l[0],height:m[3]-m[0]};},getOrientedBoundingRect:function(){var q=this.width||0;
var l=this.height||0;var s=this._matrix;var t=s[0]*q,o=s[1]*q,r=s[2]*l,m=s[3]*l,p=s[4],n=s[5];return{leftTop:[p,n],rightTop:[t+p,o+n],leftBottom:[r+p,m+n],rightBottom:[t+r+p,o+m+n]};
},getConstructor:function(){return Object.getPrototypeOf(this).constructor;}});var b=function(n){if(n._collective){return;}var l=g.Class.getInheritanceTree(n);
var m=l.indexOf(g.Entity);if(m!==-1){n._collectionTarget=l.splice(0,m+1);}else{n._collectionTarget=[];}n.intersect=d;n.intersectStrict=a;n.collection=[];
n._collective=true;};b(g.Entity);g.Entity._inherited=function(l){b(l);};g.Sprite=g.Class.create(g.Entity,{initialize:function(m,l){g.Entity.call(this);
this.width=m;this.height=l;this._image=null;this._debugColor="#ff0000";this._frameLeft=0;this._frameTop=0;this._frame=0;this._frameSequence=null;},image:{get:function(){return this._image;
},set:function(l){if(l===c){throw new Error("Assigned value on Sprite.image is undefined. Please double-check image path, and check if the image you want to use is preload before use.");
}if(l===this._image){return;}this._image=l;this._computeFramePosition();}},frame:{get:function(){return this._frame;},set:function(l){if(((this._frameSequence==null)&&(this._frame===l))||(this._deepCompareToPreviousFrame(l))){return;
}if(l instanceof Array){this._frameSequence=l;}else{this._frameSequence=null;this._frame=l;this._computeFramePosition();}}},_frameSequence:{get:function(){return this.__frameSequence;
},set:function(l){if(l&&!this.__frameSequence){this.addEventListener(g.Event.ENTER_FRAME,this._rotateFrameSequence);}else{if(!l&&this.__frameSequence){this.removeEventListener(g.Event.ENTER_FRAME,this._rotateFrameSequence);
}}if(l){this.__frameSequence=l.slice();this._originalFrameSequence=l.slice();this._rotateFrameSequence();}else{this.__frameSequence=null;this._originalFrameSequence=null;
}}},_deepCompareToPreviousFrame:function(m){if(m===this._originalFrameSequence){return true;}if(m==null||this._originalFrameSequence==null){return false;
}if(!(m instanceof Array)){return false;}if(m.length!==this._originalFrameSequence.length){return false;}for(var l=0;l<m.length;++l){if(m[l]!==this._originalFrameSequence[l]){return false;
}}return true;},_computeFramePosition:function(){var l=this._image;var m;if(l!=null){m=l.width/this._width|0;this._frameLeft=(this._frame%m|0)*this._width;
this._frameTop=(this._frame/m|0)*this._height%l.height;}},_rotateFrameSequence:function(){var l=this._frameSequence;if(l&&l.length!==0){var m=l.shift();
if(m===null){this._frameSequence=null;this.dispatchEvent(new g.Event(g.Event.ANIMATION_END));}else{this._frame=m;this._computeFramePosition();l.push(m);
}}},width:{get:function(){return this._width;},set:function(l){this._width=l;this._computeFramePosition();this._dirty=true;}},height:{get:function(){return this._height;
},set:function(l){this._height=l;this._computeFramePosition();this._dirty=true;}},cvsRender:function(v){var m=this._image,t=this._width,p=this._height,n,u,l,r,q,s,o;
if(m&&t!==0&&p!==0){n=m.width;u=m.height;if(n<t||u<p){v.fillStyle=g.Surface._getPattern(m);v.fillRect(0,0,t,p);}else{l=m._element;r=this._frameLeft;q=Math.min(this._frameTop,u-p);
s=Math.max(0.01,Math.min(n-r,t));o=Math.max(0.01,Math.min(u-q,p));v.drawImage(l,r,q,s,o,0,0,t,p);}}},domRender:(function(){if(g.ENV.VENDOR_PREFIX==="ms"){return function(l){if(this._image){if(this._image._css){this._style["background-image"]=this._image._css;
this._style["background-position"]=-this._frameLeft+"px "+-this._frameTop+"px";}else{if(this._image._element){}}}};}else{return function(l){if(this._image){if(this._image._css){this._style["background-image"]=this._image._css;
this._style["background-position"]=-this._frameLeft+"px "+-this._frameTop+"px";}else{if(this._image._element){}}}};}}())});g.Label=g.Class.create(g.Entity,{initialize:function(l){g.Entity.call(this);
this.text=l||"";this.width=300;this.font="14px serif";this.textAlign="left";this._debugColor="#ff0000";},width:{get:function(){return this._width;},set:function(l){this._width=l;
this._dirty=true;this.updateBoundArea();}},text:{get:function(){return this._text;},set:function(p){p=""+p;if(this._text===p){return;}this._text=p;p=p.replace(/<br ?\/?>/gi,"<br/>");
this._splitText=p.split("<br/>");this.updateBoundArea();for(var n=0,m=this._splitText.length;n<m;n++){p=this._splitText[n];var o=this.getMetrics(p);this._splitText[n]={};
this._splitText[n].text=p;this._splitText[n].height=o.height;this._splitText[n].width=o.width;}}},textAlign:{get:function(){return this._style["text-align"];
},set:function(l){this._style["text-align"]=l;this.updateBoundArea();}},font:{get:function(){return this._style.font;},set:function(l){this._style.font=l;
this.updateBoundArea();}},color:{get:function(){return this._style.color;},set:function(l){this._style.color=l;}},cvsRender:function(B){var z,w=0;var t=this.width;
var s,r,C,A,u,o,v,n;var m;if(this._splitText){B.textBaseline="top";B.font=this.font;B.fillStyle=this.color||"#000000";s=B.measureText(" ").width;r=t/s;
for(var q=0,p=this._splitText.length;q<p;q++){C=this._splitText[q];A=C.text;u=0;while(A.length>u+r||B.measureText(A.slice(u,u+r)).width>t){o="";v=r;n=0;
while(v>0){if(B.measureText(o).width<t){n+=v;o=A.slice(u,u+n);}else{n-=v;o=A.slice(u,u+n);}v=v/2|0;}B.fillText(o,0,w);w+=C.height-1;u+=n;}o=A.slice(u,u+A.length);
if(this.textAlign==="right"){z=t-B.measureText(o).width;}else{if(this.textAlign==="center"){z=(t-B.measureText(o).width)/2;}else{z=0;}}B.fillText(o,z,w);
w+=C.height-1;}}},domRender:function(l){if(l.innerHTML!==this._text){l.innerHTML=this._text;}},detectRender:function(l){l.fillRect(this._boundOffset,0,this._boundWidth,this._boundHeight);
},updateBoundArea:function(){var l=this.getMetrics();this._boundWidth=l.width;this._boundHeight=l.height;if(this.textAlign==="right"){this._boundOffset=this.width-this._boundWidth;
}else{if(this.textAlign==="center"){this._boundOffset=(this.width-this._boundWidth)/2;}else{this._boundOffset=0;}}},getMetrics:function(p){var n={};var r,o,l;
if(document.body){r=document.createElement("div");for(var q in this._style){if(q!=="width"&&q!=="height"){r.style[q]=this._style[q];}}p=p||this._text;r.innerHTML=p.replace(/ /g,"&nbsp;");
r.style.whiteSpace="noWrap";r.style.lineHeight=1;document.body.appendChild(r);var m=getComputedStyle(r);n.height=parseInt(m.height,10)+1;r.style.position="absolute";
n.width=parseInt(m.width,10)+1;document.body.removeChild(r);}else{n.width=this.width;n.height=this.height;}return n;}});g.Map=g.Class.create(g.Entity,{initialize:function(p,n){var m=g.Core.instance;
g.Entity.call(this);var l=new g.Surface(m.width,m.height);this._surface=l;var o=l._element;o.style.position="absolute";if(g.ENV.RETINA_DISPLAY&&m.scale===2){o.width=m.width*2;
o.height=m.height*2;this._style.webkitTransformOrigin="0 0";this._style.webkitTransform="scale(0.5)";}else{o.width=m.width;o.height=m.height;}this._context=o.getContext("2d");
this._tileWidth=p||0;this._tileHeight=n||0;this._image=null;this._data=[[[]]];this._dirty=false;this._tight=false;this.touchEnabled=false;this.collisionData=null;
this._listeners.render=null;this.addEventListener("render",function(){if(this._dirty){this._previousOffsetX=this._previousOffsetY=null;}});},loadData:function(q){this._data=Array.prototype.slice.apply(arguments);
this._dirty=true;this._tight=false;for(var p=0,n=this._data.length;p<n;p++){var t=0;q=this._data[p];for(var s=0,o=q.length;s<o;s++){for(var m=0,r=q[s].length;
m<r;m++){if(q[s][m]>=0){t++;}}}if(t/(q.length*q[0].length)>0.2){this._tight=true;break;}}},checkTile:function(m,r){if(m<0||this.width<=m||r<0||this.height<=r){return false;
}var o=this._image.width;var l=this._image.height;var q=this._tileWidth||o;var n=this._tileHeight||l;m=m/q|0;r=r/n|0;var p=this._data[0];return p[r][m];
},hitTest:function(u,s){if(u<0||this.width<=u||s<0||this.height<=s){return false;}var l=this._image.width;var v=this._image.height;var t=this._tileWidth||l;
var q=this._tileHeight||v;u=u/t|0;s=s/q|0;if(this.collisionData!=null){return this.collisionData[s]&&!!this.collisionData[s][u];}else{for(var p=0,r=this._data.length;
p<r;p++){var o=this._data[p];var m;if(o[s]!=null&&(m=o[s][u])!=null&&0<=m&&m<(l/t|0)*(v/q|0)){return true;}}return false;}},image:{get:function(){return this._image;
},set:function(n){var m=g.Core.instance;this._image=n;if(g.ENV.RETINA_DISPLAY&&m.scale===2){var o=new g.Surface(n.width*2,n.height*2);var s=this._tileWidth||n.width;
var p=this._tileHeight||n.height;var t=n.width/s|0;var l=n.height/p|0;for(var q=0;q<l;q++){for(var r=0;r<t;r++){o.draw(n,r*s,q*p,s,p,r*s*2,q*p*2,s*2,p*2);
}}this._doubledImage=o;}this._dirty=true;}},tileWidth:{get:function(){return this._tileWidth;},set:function(l){if(this._tileWidth!==l){this._tileWidth=l;
this._dirty=true;}}},tileHeight:{get:function(){return this._tileHeight;},set:function(l){if(this._tileHeight!==l){this._tileHeight=l;this._dirty=true;
}}},width:{get:function(){return this._tileWidth*this._data[0][0].length;}},height:{get:function(){return this._tileHeight*this._data[0].length;}},redraw:function(w,v,I,F){if(this._image==null){return;
}var G,l,u,A,z;if(this._doubledImage){G=this._doubledImage;l=this._tileWidth*2;u=this._tileHeight*2;A=-this._offsetX*2;z=-this._offsetY*2;w*=2;v*=2;I*=2;
F*=2;}else{G=this._image;l=this._tileWidth;u=this._tileHeight;A=-this._offsetX;z=-this._offsetY;}var s=G.width/l|0;var q=G.height/u|0;var p=Math.max((w+A)/l|0,0);
var D=Math.max((v+z)/u|0,0);var M=Math.ceil((w+A+I)/l);var t=Math.ceil((v+z+F)/u);var J=G._element;var m=this._context;var o=m.canvas;m.clearRect(w,v,I,F);
for(var K=0,L=this._data.length;K<L;K++){var O=this._data[K];var C=Math.min(M,O[0].length);var N=Math.min(t,O.length);for(v=D;v<N;v++){for(w=p;w<C;w++){var H=O[v][w];
if(0<=H&&H<s*q){var E=(H%s)*l;var B=(H/s|0)*u;m.drawImage(J,E,B,l,u,w*l-A,v*u-z,l,u);}}}}},updateBuffer:function(){if(this._visible===c||this._visible){var m=g.Core.instance;
if(this._dirty||this._previousOffsetX==null){this.redraw(0,0,m.width,m.height);}else{if(this._offsetX!==this._previousOffsetX||this._offsetY!==this._previousOffsetY){if(this._tight){var w=-this._offsetX;
var t=-this._offsetY;var A=-this._previousOffsetX;var v=-this._previousOffsetY;var p=w-A+m.width;var n=A-w+m.width;var r=t-v+m.height;var q=v-t+m.height;
if(p>this._tileWidth&&n>this._tileWidth&&r>this._tileHeight&&q>this._tileHeight){var u,s,C,B,z,o;if(p<n){u=0;C=A-w;z=p;}else{u=w-A;C=0;z=n;}if(r<q){s=0;
B=v-t;o=r;}else{s=t-v;B=0;o=q;}if(m._buffer==null){m._buffer=document.createElement("canvas");m._buffer.width=this._context.canvas.width;m._buffer.height=this._context.canvas.height;
}var l=m._buffer.getContext("2d");if(this._doubledImage){l.clearRect(0,0,z*2,o*2);l.drawImage(this._context.canvas,u*2,s*2,z*2,o*2,0,0,z*2,o*2);l=this._context;
l.clearRect(C*2,B*2,z*2,o*2);l.drawImage(m._buffer,0,0,z*2,o*2,C*2,B*2,z*2,o*2);}else{l.clearRect(0,0,z,o);l.drawImage(this._context.canvas,u,s,z,o,0,0,z,o);
l=this._context;l.clearRect(C,B,z,o);l.drawImage(m._buffer,0,0,z,o,C,B,z,o);}if(C===0){this.redraw(z,0,m.width-z,m.height);}else{this.redraw(0,0,m.width-z,m.height);
}if(B===0){this.redraw(0,o,m.width,m.height-o);}else{this.redraw(0,0,m.width,m.height-o);}}else{this.redraw(0,0,m.width,m.height);}}else{this.redraw(0,0,m.width,m.height);
}}}this._previousOffsetX=this._offsetX;this._previousOffsetY=this._offsetY;}},cvsRender:function(m){if(this.width!==0&&this.height!==0){var l=g.Core.instance;
this.updateBuffer();m.save();m.setTransform(1,0,0,1,0,0);var n=this._context.canvas;m.drawImage(n,0,0,l.width,l.height);m.restore();}},domRender:function(l){if(this._image){this.updateBuffer();
this._style["background-image"]=this._surface._css;this._style[g.ENV.VENDOR_PREFIX+"Transform"]="matrix(1, 0, 0, 1, 0, 0)";}}});g.Group=g.Class.create(g.Node,{initialize:function(){this.childNodes=[];
g.Node.call(this);this._rotation=0;this._scaleX=1;this._scaleY=1;this._originX=null;this._originY=null;this.__dirty=false;[g.Event.ADDED_TO_SCENE,g.Event.REMOVED_FROM_SCENE].forEach(function(l){this.addEventListener(l,function(m){this.childNodes.forEach(function(n){n.scene=this.scene;
n.dispatchEvent(m);},this);});},this);},addChild:function(n){if(n.parentNode){n.parentNode.removeChild(n);}this.childNodes.push(n);n.parentNode=this;var l=new g.Event("childadded");
l.node=n;l.next=null;this.dispatchEvent(l);n.dispatchEvent(new g.Event("added"));if(this.scene){n.scene=this.scene;var m=new g.Event("addedtoscene");n.dispatchEvent(m);
}},insertBefore:function(p,l){if(p.parentNode){p.parentNode.removeChild(p);}var o=this.childNodes.indexOf(l);if(o!==-1){this.childNodes.splice(o,0,p);p.parentNode=this;
var m=new g.Event("childadded");m.node=p;m.next=l;this.dispatchEvent(m);p.dispatchEvent(new g.Event("added"));if(this.scene){p.scene=this.scene;var n=new g.Event("addedtoscene");
p.dispatchEvent(n);}}else{this.addChild(p);}},removeChild:function(m){var l;if((l=this.childNodes.indexOf(m))!==-1){this.childNodes.splice(l,1);m.parentNode=null;
var n=new g.Event("childremoved");n.node=m;this.dispatchEvent(n);m.dispatchEvent(new g.Event("removed"));if(this.scene){m.scene=null;var o=new g.Event("removedfromscene");
m.dispatchEvent(o);}}},firstChild:{get:function(){return this.childNodes[0];}},lastChild:{get:function(){return this.childNodes[this.childNodes.length-1];
}},rotation:{get:function(){return this._rotation;},set:function(l){if(this._rotation!==l){this._rotation=l;this._dirty=true;}}},scaleX:{get:function(){return this._scaleX;
},set:function(l){if(this._scaleX!==l){this._scaleX=l;this._dirty=true;}}},scaleY:{get:function(){return this._scaleY;},set:function(l){if(this._scaleY!==l){this._scaleY=l;
this._dirty=true;}}},originX:{get:function(){return this._originX;},set:function(l){if(this._originX!==l){this._originX=l;this._dirty=true;}}},originY:{get:function(){return this._originY;
},set:function(l){if(this._originY!==l){this._originY=l;this._dirty=true;}}},_dirty:{get:function(){return this.__dirty;},set:function(o){o=!!o;this.__dirty=o;
if(o){for(var n=0,m=this.childNodes.length;n<m;n++){this.childNodes[n]._dirty=true;}}}}});g.Matrix=g.Class.create({initialize:function(){this.reset();},reset:function(){this.stack=[];
this.stack.push([1,0,0,1,0,0]);},makeTransformMatrix:function(u,p){var q=u._x;var o=u._y;var t=u.width||0;var s=u.height||0;var v=u._rotation||0;var D=(typeof u._scaleX==="number")?u._scaleX:1;
var B=(typeof u._scaleY==="number")?u._scaleY:1;var n=v*Math.PI/180;var m=Math.cos(n);var l=Math.sin(n);var r=(typeof u._originX==="number")?u._originX:t/2;
var z=(typeof u._originY==="number")?u._originY:s/2;var F=D*m;var E=D*l;var C=B*l;var A=B*m;p[0]=F;p[1]=E;p[2]=-C;p[3]=A;p[4]=(-F*r+C*z+q+r);p[5]=(-E*r-A*z+o+z);
},multiply:function(z,x,v){var y=z[0],s=z[2],n=z[4],w=z[1],r=z[3],l=z[5];var o=x[0],u=x[2],q=x[4],m=x[1],t=x[3],p=x[5];v[0]=y*o+s*m;v[1]=w*o+r*m;v[2]=y*u+s*t;
v[3]=w*u+r*t;v[4]=y*q+s*p+n;v[5]=w*q+r*p+l;},multiplyVec:function(v,n,u){var t=n[0],s=n[1];var p=v[0],m=v[2],r=v[4],o=v[1],l=v[3],q=v[5];u[0]=p*t+m*s+r;
u[1]=o*t+l*s+q;}});g.Matrix.instance=new g.Matrix();g.DetectColorManager=g.Class.create({initialize:function(p,m){this.reference=[];this.colorResolution=p||16;
this.max=m||1;this.capacity=Math.pow(this.colorResolution,3);for(var o=1,n=this.capacity;o<n;o++){this.reference[o]=null;}},attachDetectColor:function(m){var l=this.reference.indexOf(null);
if(l===-1){l=1;}this.reference[l]=m;return this._getColor(l);},detachDetectColor:function(m){var l=this.reference.indexOf(m);if(l!==-1){this.reference[l]=null;
}},_getColor:function(o){var m=this.colorResolution;var l=m/this.max;return[parseInt((o/m/m)%m,10)/l,parseInt((o/m)%m,10)/l,parseInt(o%m,10)/l,1];},_decodeDetectColor:function(l,m){m=m||0;
var n=this.colorResolution;return ~~(l[m]*n*n*n/256)+~~(l[m+1]*n*n/256)+~~(l[m+2]*n/256);},getSpriteByColor:function(l){return this.reference[this._decodeDetectColor(l)];
},getSpriteByColors:function(p){var o,n,s,m,r=0,q={};for(o=0,n=p.length;o<n;o+=4){s=this._decodeDetectColor(p,o);q[s]=(q[s]||0)+1;}for(s in q){if(q[s]>r){r=q[s];
m=s;}}return this.reference[m];}});g.DomManager=g.Class.create({initialize:function(n,o){var l=g.Core.instance;this.layer=null;this.targetNode=n;if(typeof o==="string"){this.element=document.createElement(o);
}else{if(o instanceof HTMLElement){this.element=o;}}this.style=this.element.style;this.style.position="absolute";this.style[g.ENV.VENDOR_PREFIX+"TransformOrigin"]="0px 0px";
if(l._debug){this.style.border="1px solid blue";this.style.margin="-1px";}var m=this;this._setDomTarget=function(){m.layer._touchEventTarget=m.targetNode;
};this._attachEvent();},getDomElement:function(){return this.element;},getDomElementAsNext:function(){return this.element;},getNextManager:function(m){var l=this.targetNode.parentNode.childNodes.indexOf(m.targetNode);
if(l!==this.targetNode.parentNode.childNodes.length-1){return this.targetNode.parentNode.childNodes[l+1]._domManager;}else{return null;}},addManager:function(l,o){var n;
if(o){n=o.getDomElementAsNext();}var m=l.getDomElement();if(m instanceof Array){m.forEach(function(p){if(n){this.element.insertBefore(p,n);}else{this.element.appendChild(p);
}},this);}else{if(n){this.element.insertBefore(m,n);}else{this.element.appendChild(m);}}this.setLayer(this.layer);},removeManager:function(l){if(l instanceof g.DomlessManager){l._domRef.forEach(function(m){this.element.removeChild(m);
},this);}else{this.element.removeChild(l.element);}this.setLayer(this.layer);},setLayer:function(p){this.layer=p;var q=this.targetNode;var o;if(q.childNodes){for(var n=0,m=q.childNodes.length;
n<m;n++){o=q.childNodes[n]._domManager;if(o){o.setLayer(p);}}}},render:function(s){var r=this.targetNode;var o=g.Matrix.instance;var l=o.stack;var p=[];
o.makeTransformMatrix(r,p);o.multiply(l[l.length-1],p,p);o.multiply(s,p,s);r._matrix=s;var n=(typeof r._originX==="number")?r._originX:r.width/2||0;var m=(typeof r._originY==="number")?r._originY:r.height/2||0;
var q=[n,m];o.multiplyVec(p,q,q);r._offsetX=q[0]-n;r._offsetY=q[1]-m;if(r.parentNode&&!(r.parentNode instanceof g.Group)){r._offsetX+=r.parentNode._offsetX;
r._offsetY+=r.parentNode._offsetY;}if(r._dirty){this.style[g.ENV.VENDOR_PREFIX+"Transform"]="matrix("+p[0].toFixed(10)+","+p[1].toFixed(10)+","+p[2].toFixed(10)+","+p[3].toFixed(10)+","+p[4].toFixed(10)+","+p[5].toFixed(10)+")";
}this.domRender();},domRender:function(){var l=this.targetNode;if(!l._style){l._style={};}if(!l.__styleStatus){l.__styleStatus={};}if(l.width!==null){l._style.width=l.width+"px";
}if(l.height!==null){l._style.height=l.height+"px";}l._style.opacity=l._opacity;l._style["background-color"]=l._backgroundColor;if(typeof l._visible!=="undefined"){l._style.display=l._visible?"block":"none";
}if(typeof l.domRender==="function"){l.domRender(this.element);}var m;for(var n in l._style){m=l._style[n];if(l.__styleStatus[n]!==m&&m!=null){this.style.setProperty(n,""+m);
l.__styleStatus[n]=m;}}},_attachEvent:function(){if(g.ENV.TOUCH_ENABLED){this.element.addEventListener("touchstart",this._setDomTarget,true);}this.element.addEventListener("mousedown",this._setDomTarget,true);
},_detachEvent:function(){if(g.ENV.TOUCH_ENABLED){this.element.removeEventListener("touchstart",this._setDomTarget,true);}this.element.removeEventListener("mousedown",this._setDomTarget,true);
},remove:function(){this._detachEvent();this.element=this.style=this.targetNode=null;}});g.DomlessManager=g.Class.create({initialize:function(l){this._domRef=[];
this.targetNode=l;},_register:function(n,m){var l=this._domRef.indexOf(m);if(n instanceof Array){if(l===-1){Array.prototype.push.apply(this._domRef,n);
}else{Array.prototype.splice.apply(this._domRef,[l,0].concat(n));}}else{if(l===-1){this._domRef.push(n);}else{this._domRef.splice(l,0,n);}}},getNextManager:function(m){var l=this.targetNode.parentNode.childNodes.indexOf(m.targetNode);
if(l!==this.targetNode.parentNode.childNodes.length-1){return this.targetNode.parentNode.childNodes[l+1]._domManager;}else{return null;}},getDomElement:function(){var l=[];
this.targetNode.childNodes.forEach(function(m){l=l.concat(m._domManager.getDomElement());});return l;},getDomElementAsNext:function(){if(this._domRef.length){return this._domRef[0];
}else{var l=this.getNextManager(this);if(l){return l.element;}else{return null;}}},addManager:function(m,o){var l=this.targetNode.parentNode;if(l){if(o===null){o=this.getNextManager(this);
}if(l instanceof g.Scene){l._layers.Dom._domManager.addManager(m,o);}else{l._domManager.addManager(m,o);}}var n=o?o.getDomElementAsNext():null;this._register(m.getDomElement(),n);
this.setLayer(this.layer);},removeManager:function(l){var n;var m=this._domRef.indexOf(l.element);if(m!==-1){n=this._domRef[m];n.parentNode.removeChild(n);
this._domRef.splice(m,1);}this.setLayer(this.layer);},setLayer:function(p){this.layer=p;var q=this.targetNode;var o;if(q.childNodes){for(var n=0,m=q.childNodes.length;
n<m;n++){o=q.childNodes[n]._domManager;if(o){o.setLayer(p);}}}},render:function(s){var o=g.Matrix.instance;var l=o.stack;var r=this.targetNode;var p=[];
o.makeTransformMatrix(r,p);o.multiply(l[l.length-1],p,p);o.multiply(s,p,s);r._matrix=s;var n=(typeof r._originX==="number")?r._originX:r.width/2||0;var m=(typeof r._originY==="number")?r._originY:r.height/2||0;
var q=[n,m];o.multiplyVec(p,q,q);r._offsetX=q[0]-n;r._offsetY=q[1]-m;l.push(p);},remove:function(){this._domRef=[];this.targetNode=null;}});g.DomLayer=g.Class.create(g.Group,{initialize:function(){var l=g.Core.instance;
g.Group.call(this);this._touchEventTarget=null;this._element=document.createElement("div");this._element.style.position="absolute";this._domManager=new g.DomManager(this,this._element);
this._domManager.layer=this;this.width=l.width;this.height=l.height;var o=[g.Event.TOUCH_START,g.Event.TOUCH_MOVE,g.Event.TOUCH_END];o.forEach(function(p){this.addEventListener(p,function(q){if(this._scene){this._scene.dispatchEvent(q);
}});},this);var m=function(t){var u=t.node;var r=t.next;var p=t.target;var s=r?r._domManager:null;g.DomLayer._attachDomManager(u,m,n);p._domManager.addManager(u._domManager,s);
var q=new g.Event(g.Event.RENDER);u._dirty=true;p._domManager.layer._rendering(u,q);};var n=function(q){var r=q.node;var p=q.target;p._domManager.removeManager(r._domManager);
g.DomLayer._detachDomManager(r,m,n);};this.addEventListener("childremoved",n);this.addEventListener("childadded",m);},width:{get:function(){return this._width;
},set:function(l){this._width=l;this._element.style.width=l+"px";}},height:{get:function(){return this._height;},set:function(l){this._height=l;this._element.style.height=l+"px";
}},addChild:function(n){this.childNodes.push(n);n.parentNode=this;var l=new g.Event("childadded");l.node=n;l.next=null;this.dispatchEvent(l);n.dispatchEvent(new g.Event("added"));
if(this.scene){n.scene=this.scene;var m=new g.Event("addedtoscene");n.dispatchEvent(m);}},insertBefore:function(p,l){var o=this.childNodes.indexOf(l);if(o!==-1){this.childNodes.splice(o,0,p);
p.parentNode=this;var m=new g.Event("childadded");m.node=p;m.next=l;this.dispatchEvent(m);p.dispatchEvent(new g.Event("added"));if(this.scene){p.scene=this.scene;
var n=new g.Event("addedtoscene");p.dispatchEvent(n);}}else{this.addChild(p);}},_startRendering:function(){this.addEventListener("exitframe",this._onexitframe);
this._onexitframe();},_stopRendering:function(){this.removeEventListener("exitframe",this._onexitframe);this._onexitframe();},_onexitframe:function(){this._rendering(this,new g.Event(g.Event.RENDER));
},_rendering:function(o,p,q){var r;if(!q){q=[1,0,0,1,0,0];}o.dispatchEvent(p);o._domManager.render(q);if(o.childNodes){for(var n=0,m=o.childNodes.length;
n<m;n++){r=o.childNodes[n];this._rendering(r,p,q.slice());}}if(o._domManager instanceof g.DomlessManager){g.Matrix.instance.stack.pop();}o._dirty=false;
},_determineEventTarget:function(){var l=this._touchEventTarget;this._touchEventTarget=null;return(l===this)?null:l;}});g.DomLayer._attachDomManager=function(q,p,o){var r;
if(!q._domManager){q.addEventListener("childadded",p);q.addEventListener("childremoved",o);if(q instanceof g.Group){q._domManager=new g.DomlessManager(q);
}else{if(q._element){q._domManager=new g.DomManager(q,q._element);}else{q._domManager=new g.DomManager(q,"div");}}}if(q.childNodes){for(var n=0,m=q.childNodes.length;
n<m;n++){r=q.childNodes[n];g.DomLayer._attachDomManager(r,p,o);q._domManager.addManager(r._domManager,null);}}};g.DomLayer._detachDomManager=function(q,p,o){var r;
q.removeEventListener("childadded",p);q.removeEventListener("childremoved",o);if(q.childNodes){for(var n=0,m=q.childNodes.length;n<m;n++){r=q.childNodes[n];
q._domManager.removeManager(r._domManager,null);g.DomLayer._detachDomManager(r,p,o);}}q._domManager.remove();delete q._domManager;};g.CanvasLayer=g.Class.create(g.Group,{initialize:function(){var l=g.Core.instance;
g.Group.call(this);this._cvsCache={matrix:[1,0,0,1,0,0],detectColor:"#000000"};this._cvsCache.layer=this;this._element=document.createElement("canvas");
this._element.style.position="absolute";this._element.style.left=this._element.style.top="0px";this._detect=document.createElement("canvas");this._detect.style.position="absolute";
this._lastDetected=0;this.context=this._element.getContext("2d");this._dctx=this._detect.getContext("2d");this._setImageSmoothingEnable();this._colorManager=new g.DetectColorManager(16,256);
this.width=l.width;this.height=l.height;var o=[g.Event.TOUCH_START,g.Event.TOUCH_MOVE,g.Event.TOUCH_END];o.forEach(function(p){this.addEventListener(p,function(q){if(this._scene){this._scene.dispatchEvent(q);
}});},this);var m=function(s){var t=s.node;var p=s.target;var q;if(p instanceof g.CanvasLayer){q=p._scene._layers.Canvas;}else{q=p.scene._layers.Canvas;
}g.CanvasLayer._attachCache(t,q,m,n);var r=new g.Event(g.Event.RENDER);if(p._dirty){p._updateCoordinate();}t._dirty=true;g.Matrix.instance.stack.push(p._matrix);
g.CanvasRenderer.instance.render(q.context,t,r);g.Matrix.instance.stack.pop(p._matrix);};var n=function(r){var s=r.node;var p=r.target;var q;if(p instanceof g.CanvasLayer){q=p._scene._layers.Canvas;
}else{q=p.scene._layers.Canvas;}g.CanvasLayer._detachCache(s,q,m,n);};this.addEventListener("childremoved",n);this.addEventListener("childadded",m);},width:{get:function(){return this._width;
},set:function(l){this._width=l;this._element.width=this._detect.width=l;this._setImageSmoothingEnable();}},height:{get:function(){return this._height;
},set:function(l){this._height=l;this._element.height=this._detect.height=l;this._setImageSmoothingEnable();}},addChild:function(m){this.childNodes.push(m);
m.parentNode=this;var l=new g.Event("childadded");l.node=m;l.next=null;this.dispatchEvent(l);m.dispatchEvent(new g.Event("added"));},insertBefore:function(o,l){var n=this.childNodes.indexOf(l);
if(n!==-1){this.childNodes.splice(n,0,o);o.parentNode=this;var m=new g.Event("childadded");m.node=o;m.next=l;this.dispatchEvent(m);o.dispatchEvent(new g.Event("added"));
}else{this.addChild(o);}},_startRendering:function(){this.addEventListener("exitframe",this._onexitframe);this._onexitframe();},_stopRendering:function(){this.removeEventListener("exitframe",this._onexitframe);
this._onexitframe();},_onexitframe:function(){var m=g.Core.instance;var l=this.context;l.clearRect(0,0,m.width,m.height);var n=new g.Event(g.Event.RENDER);
g.CanvasRenderer.instance.render(l,this,n);},_determineEventTarget:function(l){return this._getEntityByPosition(l.x,l.y);},_getEntityByPosition:function(m,q){var o=g.Core.instance;
var n=this._dctx;if(this._lastDetected<o.frame){n.clearRect(0,0,this.width,this.height);g.CanvasRenderer.instance.detectRender(n,this);this._lastDetected=o.frame;
}var l=g.ENV.COLOR_DETECTION_LEVEL-1;var p=n.getImageData(m-l,q-l,1+l*2,1+l*2).data;return this._colorManager.getSpriteByColors(p);},_setImageSmoothingEnable:function(){this._dctx.imageSmoothingEnabled=this._dctx.msImageSmoothingEnabled=this._dctx.mozImageSmoothingEnabled=this._dctx.webkitImageSmoothingEnabled=false;
}});g.CanvasLayer._attachCache=function(r,p,q,o){var s;if(!r._cvsCache){r._cvsCache={};r._cvsCache.matrix=[1,0,0,1,0,0];r._cvsCache.detectColor="rgba("+p._colorManager.attachDetectColor(r)+")";
r.addEventListener("childadded",q);r.addEventListener("childremoved",o);}if(r.childNodes){for(var n=0,m=r.childNodes.length;n<m;n++){s=r.childNodes[n];
g.CanvasLayer._attachCache(s,p,q,o);}}};g.CanvasLayer._detachCache=function(r,p,q,o){var s;if(r._cvsCache){p._colorManager.detachDetectColor(r);r.removeEventListener("childadded",q);
r.removeEventListener("childremoved",o);delete r._cvsCache;}if(r.childNodes){for(var n=0,m=r.childNodes.length;n<m;n++){s=r.childNodes[n];g.CanvasLayer._detachCache(s,p,q,o);
}}};g.CanvasRenderer=g.Class.create({render:function(o,r,s){var q,m,t;o.save();r.dispatchEvent(s);this.transform(o,r);if(typeof r._visible==="undefined"||r._visible){q=r.width;
m=r.height;if(r.compositeOperation){o.globalCompositeOperation=r.compositeOperation;}o.globalAlpha=(typeof r._opacity==="number")?r._opacity:1;if(r._backgroundColor){o.fillStyle=r._backgroundColor;
o.fillRect(0,0,q,m);}if(r.cvsRender){r.cvsRender(o);}if(g.Core.instance._debug&&r._debugColor){o.strokeStyle=r._debugColor;o.strokeRect(0,0,q,m);}if(r._clipping){o.beginPath();
o.rect(0,0,q,m);o.clip();}if(r.childNodes){for(var p=0,n=r.childNodes.length;p<n;p++){t=r.childNodes[p];this.render(o,t,s);}}}o.restore();g.Matrix.instance.stack.pop();
},detectRender:function(o,r){var q,m,s;if(typeof r._visible==="undefined"||r._visible){q=r.width;m=r.height;o.save();this.transform(o,r);o.fillStyle=r._cvsCache.detectColor;
if(r._touchEnabled){if(r.detectRender){r.detectRender(o);}else{o.fillRect(0,0,q,m);}}if(r._clipping){o.beginPath();o.rect(0,0,q,m);o.clip();}if(r.childNodes){for(var p=0,n=r.childNodes.length;
p<n;p++){s=r.childNodes[p];this.detectRender(o,s);}}o.restore();g.Matrix.instance.stack.pop();}},transform:function(n,s){var q=g.Matrix.instance;var l=q.stack;
var p,o,m,r;if(s._dirty){q.makeTransformMatrix(s,s._cvsCache.matrix);p=[];q.multiply(l[l.length-1],s._cvsCache.matrix,p);s._matrix=p;o=(typeof s._originX==="number")?s._originX:s._width/2||0;
m=(typeof s._originY==="number")?s._originY:s._height/2||0;r=[o,m];q.multiplyVec(p,r,r);s._offsetX=r[0]-o;s._offsetY=r[1]-m;s._dirty=false;}else{p=s._matrix;
}l.push(p);n.setTransform.apply(n,p);}});g.CanvasRenderer.instance=new g.CanvasRenderer();g.Scene=g.Class.create(g.Group,{initialize:function(){var l=g.Core.instance;
g.Group.call(this);this.scene=this;this._backgroundColor=null;this._element=document.createElement("div");this._element.style.position="absolute";this._element.style.overflow="hidden";
this._element.style[g.ENV.VENDOR_PREFIX+"TransformOrigin"]="0 0";this._layers={};this._layerPriority=[];this.addEventListener(g.Event.CHILD_ADDED,this._onchildadded);
this.addEventListener(g.Event.CHILD_REMOVED,this._onchildremoved);this.addEventListener(g.Event.ENTER,this._onenter);this.addEventListener(g.Event.EXIT,this._onexit);
var m=this;this._dispatchExitframe=function(){var n;for(var o in m._layers){n=m._layers[o];n.dispatchEvent(new g.Event(g.Event.EXIT_FRAME));}};this.addEventListener(g.Event.CORE_RESIZE,this._oncoreresize);
this._oncoreresize(l);},x:{get:function(){return this._x;},set:function(l){this._x=l;for(var m in this._layers){this._layers[m].x=l;}}},y:{get:function(){return this._y;
},set:function(m){this._y=m;for(var l in this._layers){this._layers[l].y=m;}}},width:{get:function(){return this._width;},set:function(m){this._width=m;
for(var l in this._layers){this._layers[l].width=m;}}},height:{get:function(){return this._height;},set:function(l){this._height=l;for(var m in this._layers){this._layers[m].height=l;
}}},rotation:{get:function(){return this._rotation;},set:function(l){this._rotation=l;for(var m in this._layers){this._layers[m].rotation=l;}}},scaleX:{get:function(){return this._scaleX;
},set:function(l){this._scaleX=l;for(var m in this._layers){this._layers[m].scaleX=l;}}},scaleY:{get:function(){return this._scaleY;},set:function(l){this._scaleY=l;
for(var m in this._layers){this._layers[m].scaleY=l;}}},backgroundColor:{get:function(){return this._backgroundColor;},set:function(l){this._backgroundColor=this._element.style.backgroundColor=l;
}},remove:function(){this.clearEventListener();while(this.childNodes.length>0){this.childNodes[0].remove();}return g.Core.instance.removeScene(this);},_oncoreresize:function(m){this._element.style.width=m.width+"px";
this.width=m.width;this._element.style.height=m.height+"px";this.height=m.height;this._element.style[g.ENV.VENDOR_PREFIX+"Transform"]="scale("+m.scale+")";
for(var l in this._layers){this._layers[l].dispatchEvent(m);}},addLayer:function(p,o){var l=g.Core.instance;if(this._layers[p]){return;}var n=new g[p+"Layer"]();
if(l.currentScene===this){n._startRendering();}this._layers[p]=n;var m=n._element;if(typeof o==="number"){var q=this._element.childNodes[o];if(q){this._element.insertBefore(m,q);
}else{this._element.appendChild(m);}this._layerPriority.splice(o,0,p);}else{this._element.appendChild(m);this._layerPriority.push(p);}n._scene=this;},_determineEventTarget:function(o){var m,n;
for(var l=this._layerPriority.length-1;l>=0;l--){m=this._layers[this._layerPriority[l]];n=m._determineEventTarget(o);if(n){break;}}if(!n){n=this;}return n;
},_onchildadded:function(o){var p=o.node;var m=o.next;var n,l;if(p._element){n="Dom";l=1;}else{n="Canvas";l=0;}if(!this._layers[n]){this.addLayer(n,l);
}p._layer=this._layers[n];this._layers[n].insertBefore(p,m);p.parentNode=this;},_onchildremoved:function(l){var m=l.node;m._layer.removeChild(m);m._layer=null;
},_onenter:function(){for(var l in this._layers){this._layers[l]._startRendering();}g.Core.instance.addEventListener("exitframe",this._dispatchExitframe);
},_onexit:function(){for(var l in this._layers){this._layers[l]._stopRendering();}g.Core.instance.removeEventListener("exitframe",this._dispatchExitframe);
}});g.LoadingScene=g.Class.create(g.Scene,{initialize:function(){g.Scene.call(this);this.backgroundColor="#000";var o=this.width*0.4|0;var r=this.width*0.05|0;
var m=o*0.03|0;var p=new g.Sprite(o,r);p.disableCollection();p.x=(this.width-o)/2;p.y=(this.height-r)/2;var q=new g.Surface(o,r);q.context.fillStyle="#fff";
q.context.fillRect(0,0,o,r);q.context.fillStyle="#000";q.context.fillRect(m,m,o-m*2,r-m*2);p.image=q;var l=0,n=0;this.addEventListener("progress",function(s){l=s.loaded/s.total*1;
});p.addEventListener("enterframe",function(){n*=0.9;n+=l*0.1;q.context.fillStyle="#fff";q.context.fillRect(m,0,(o-m*2)*n,r);});this.addChild(p);this.addEventListener("load",function(t){var s=g.Core.instance;
s.removeScene(s.loadingScene);s.dispatchEvent(t);});}});g.CanvasScene=g.Class.create(g.Scene,{initialize:function(){g.Scene.call(this);this.addLayer("Canvas");
},_determineEventTarget:function(m){var l=this._layers.Canvas._determineEventTarget(m);if(!l){l=this;}return l;},_onchildadded:function(m){var n=m.node;
var l=m.next;n._layer=this._layers.Canvas;this._layers.Canvas.insertBefore(n,l);},_onenter:function(){this._layers.Canvas._startRendering();g.Core.instance.addEventListener("exitframe",this._dispatchExitframe);
},_onexit:function(){this._layers.Canvas._stopRendering();g.Core.instance.removeEventListener("exitframe",this._dispatchExitframe);}});g.DOMScene=g.Class.create(g.Scene,{initialize:function(){g.Scene.call(this);
this.addLayer("Dom");},_determineEventTarget:function(m){var l=this._layers.Dom._determineEventTarget(m);if(!l){l=this;}return l;},_onchildadded:function(m){var n=m.node;
var l=m.next;n._layer=this._layers.Dom;this._layers.Dom.insertBefore(n,l);},_onenter:function(){this._layers.Dom._startRendering();g.Core.instance.addEventListener("exitframe",this._dispatchExitframe);
},_onexit:function(){this._layers.Dom._stopRendering();g.Core.instance.removeEventListener("exitframe",this._dispatchExitframe);}});g.Surface=g.Class.create(g.EventTarget,{initialize:function(o,l){g.EventTarget.call(this);
var m=g.Core.instance;this.width=Math.ceil(o);this.height=Math.ceil(l);this.context=null;var p="enchant-surface"+m._surfaceID++;if(document.getCSSCanvasContext){this.context=document.getCSSCanvasContext("2d",p,o,l);
this._element=this.context.canvas;this._css="-webkit-canvas("+p+")";var n=this.context;}else{if(document.mozSetImageElement){this._element=document.createElement("canvas");
this._element.width=o;this._element.height=l;this._css="-moz-element(#"+p+")";this.context=this._element.getContext("2d");document.mozSetImageElement(p,this._element);
}else{this._element=document.createElement("canvas");this._element.width=o;this._element.height=l;this._element.style.position="absolute";this.context=this._element.getContext("2d");
g.ENV.CANVAS_DRAWING_METHODS.forEach(function(q){var r=this.context[q];this.context[q]=function(){r.apply(this,arguments);this._dirty=true;};},this);}}},getPixel:function(l,m){return this.context.getImageData(l,m,1,1).data;
},setPixel:function(m,s,q,p,l,n){var o=this.context.createImageData(1,1);o.data[0]=q;o.data[1]=p;o.data[2]=l;o.data[3]=n;this.context.putImageData(o,m,s);
},clear:function(){this.context.clearRect(0,0,this.width,this.height);},draw:function(m){m=m._element;if(arguments.length===1){this.context.drawImage(m,0,0);
}else{var l=arguments;l[0]=m;this.context.drawImage.apply(this.context,l);}},clone:function(){var l=new g.Surface(this.width,this.height);l.draw(this);
return l;},toDataURL:function(){var l=this._element.src;if(l){if(l.slice(0,5)==="data:"){return l;}else{return this.clone().toDataURL();}}else{return this._element.toDataURL();
}}});g.Surface.load=function(o,p,m){var n=new Image();var l=Object.create(g.Surface.prototype,{context:{value:null},_css:{value:"url("+o+")"},_element:{value:n}});
g.EventTarget.call(l);m=m||function(){};l.addEventListener("load",p);l.addEventListener("error",m);n.onerror=function(){var q=new g.Event(g.Event.ERROR);
q.message="Cannot load an asset: "+n.src;g.Core.instance.dispatchEvent(q);l.dispatchEvent(q);};n.onload=function(){l.width=n.width;l.height=n.height;l.dispatchEvent(new g.Event("load"));
};n.src=o;return l;};g.Surface._staticCanvas2DContext=document.createElement("canvas").getContext("2d");g.Surface._getPattern=function(l,m){if(!l._pattern||m){l._pattern=this._staticCanvas2DContext.createPattern(l._element,"repeat");
}return l._pattern;};if(f.Deferred){g.Deferred=f.Deferred;}else{g.Deferred=g.Class.create({initialize:function(){this._succ=this._fail=this._next=this._id=null;
this._tail=this;},next:function(l){var m=new g.Deferred();m._succ=l;return this._add(m);},error:function(l){var m=new g.Deferred();m._fail=l;return this._add(m);
},_add:function(l){this._tail._next=l;this._tail=l;return this;},call:function(m){var o;var l=this;while(l&&!l._succ){l=l._next;}if(!(l instanceof g.Deferred)){return;
}try{o=l._succ(m);}catch(n){return l.fail(n);}if(o instanceof g.Deferred){g.Deferred._insert(l,o);}else{if(l._next instanceof g.Deferred){l._next.call(o);
}}},fail:function(n){var m,o,l=this;while(l&&!l._fail){l=l._next;}if(l instanceof g.Deferred){m=l._fail(n);l.call(m);}else{if(n instanceof Error){throw n;
}else{o=new Error("failed in Deferred");o.arg=n;throw o;}}}});g.Deferred._insert=function(l,m){if(l._next instanceof g.Deferred){m._tail._next=l._next;
}l._next=m;};g.Deferred.next=function(l){var m=new g.Deferred().next(l);m._id=setTimeout(function(){m.call();},0);return m;};g.Deferred.parallel=function(l){var o=new g.Deferred();
o._id=setTimeout(function(){o.call();},0);var n=0;var m=(l instanceof Array)?[]:{};var r=new g.Deferred();for(var s in l){if(l.hasOwnProperty(s)){n++;(function(p,q){p.next(function(t){n--;
m[q]=t;if(n<=0){r.call(m);}}).error(function(t){r.fail(t);});if(typeof p._id==="number"){clearTimeout(p._id);}p._id=setTimeout(function(){p.call();},0);
}(l[s],s));}}if(!n){r._id=setTimeout(function(){r.call(m);},0);}return o.next(function(){return r;});};}g.DOMSound=g.Class.create(g.EventTarget,{initialize:function(){g.EventTarget.call(this);
this.duration=0;throw new Error("Illegal Constructor");},play:function(){if(this._element){this._element.play();}},pause:function(){if(this._element){this._element.pause();
}},stop:function(){this.pause();this.currentTime=0;},clone:function(){var l;if(this._element instanceof Audio){l=Object.create(g.DOMSound.prototype,{_element:{value:this._element.cloneNode(false)},duration:{value:this.duration}});
}else{if(g.ENV.USE_FLASH_SOUND){return this;}else{l=Object.create(g.DOMSound.prototype);}}g.EventTarget.call(l);return l;},currentTime:{get:function(){return this._element?this._element.currentTime:0;
},set:function(l){if(this._element){this._element.currentTime=l;}}},volume:{get:function(){return this._element?this._element.volume:1;},set:function(l){if(this._element){this._element.volume=l;
}}}});g.DOMSound.load=function(l,r,u,s){if(r==null){var n=g.Core.findExt(l);if(n){r="audio/"+n;}else{r="";}}r=r.replace("mp3","mpeg").replace("m4a","mp4");
u=u||function(){};s=s||function(){};var t=Object.create(g.DOMSound.prototype);g.EventTarget.call(t);t.addEventListener("load",u);t.addEventListener("error",s);
var p=new Audio();if(!g.ENV.SOUND_ENABLED_ON_MOBILE_SAFARI&&g.ENV.VENDOR_PREFIX==="webkit"&&g.ENV.TOUCH_ENABLED){f.setTimeout(function(){t.dispatchEvent(new g.Event("load"));
},0);}else{if(!g.ENV.USE_FLASH_SOUND&&p.canPlayType(r)){p.addEventListener("canplaythrough",function o(){t.duration=p.duration;t.dispatchEvent(new g.Event("load"));
p.removeEventListener("canplaythrough",o);},false);p.src=l;p.load();p.autoplay=false;p.onerror=function(){var v=new g.Event(g.Event.ERROR);v.message="Cannot load an asset: "+p.src;
g.Core.instance.dispatchEvent(v);t.dispatchEvent(v);};t._element=p;}else{if(r==="audio/mpeg"){var q=document.createElement("embed");var m="enchant-audio"+g.Core.instance._soundID++;
q.width=q.height=1;q.name=m;q.src="sound.swf?id="+m+"&src="+l;q.allowscriptaccess="always";q.style.position="absolute";q.style.left="-1px";t.addEventListener("load",function(){Object.defineProperties(q,{currentTime:{get:function(){return q.getCurrentTime();
},set:function(v){q.setCurrentTime(v);}},volume:{get:function(){return q.getVolume();},set:function(v){q.setVolume(v);}}});t._element=q;t.duration=q.getDuration();
});g.Core.instance._element.appendChild(q);g.DOMSound[m]=t;}else{f.setTimeout(function(){t.dispatchEvent(new g.Event("load"));},0);}}}return t;};f.AudioContext=f.AudioContext||f.webkitAudioContext||f.mozAudioContext||f.msAudioContext||f.oAudioContext;
g.WebAudioSound=g.Class.create(g.EventTarget,{initialize:function(){if(!f.AudioContext){throw new Error("This browser does not support WebAudio API.");
}g.EventTarget.call(this);if(!g.WebAudioSound.audioContext){g.WebAudioSound.audioContext=new f.AudioContext();g.WebAudioSound.destination=g.WebAudioSound.audioContext.destination;
}this.context=g.WebAudioSound.audioContext;this.src=this.context.createBufferSource();this.buffer=null;this._volume=1;this._currentTime=0;this._state=0;
this.connectTarget=g.WebAudioSound.destination;},play:function(m){if(this._state===1&&!m){this.src.disconnect();}if(this._state!==2){this._currentTime=0;
}var n=this._currentTime;var l=this.context;this.src=l.createBufferSource();if(l.createGain!=null){this._gain=l.createGain();}else{this._gain=l.createGainNode();
}this.src.buffer=this.buffer;this._gain.gain.value=this._volume;this.src.connect(this._gain);this._gain.connect(this.connectTarget);if(this.src.start!=null){this.src.start(0,n,this.buffer.duration-n-1.192e-7);
}else{this.src.noteGrainOn(0,n,this.buffer.duration-n-1.192e-7);}this._startTime=l.currentTime-this._currentTime;this._state=1;},pause:function(){var l=this.currentTime;
if(l===this.duration){return;}if(this.src.stop!=null){this.src.stop(0);}else{this.src.noteOff(0);}this._currentTime=l;this._state=2;},stop:function(){if(this.src.stop!=null){this.src.stop(0);
}else{this.src.noteOff(0);}this._state=0;},clone:function(){var l=new g.WebAudioSound();l.buffer=this.buffer;return l;},duration:{get:function(){if(this.buffer){return this.buffer.duration;
}else{return 0;}}},volume:{get:function(){return this._volume;},set:function(l){l=Math.max(0,Math.min(1,l));this._volume=l;if(this.src){this._gain.gain.value=l;
}}},currentTime:{get:function(){return Math.max(0,Math.min(this.duration,this.src.context.currentTime-this._startTime));},set:function(l){this._currentTime=l;
if(this._state!==2){this.play(false);}}}});g.WebAudioSound.load=function(l,p,s,q){var n=(new Audio()).canPlayType(p);var r=new g.WebAudioSound();s=s||function(){};
q=q||function(){};r.addEventListener(g.Event.LOAD,s);r.addEventListener(g.Event.ERROR,q);function m(){var u=new g.Event(g.Event.ERROR);u.message="Cannot load an asset: "+l;
g.Core.instance.dispatchEvent(u);r.dispatchEvent(u);}var o,t;if(n==="maybe"||n==="probably"){o=g.WebAudioSound.audioContext;t=new XMLHttpRequest();t.open("GET",l,true);
t.responseType="arraybuffer";t.onload=function(){o.decodeAudioData(t.response,function(u){r.buffer=u;r.dispatchEvent(new g.Event(g.Event.LOAD));},m);};
t.onerror=m;t.send(null);}else{setTimeout(m,50);}return r;};g.Sound=f.AudioContext&&g.ENV.USE_WEBAUDIO?g.WebAudioSound:g.DOMSound;g.Easing={LINEAR:function(m,l,o,n){return o*m/n+l;
},SWING:function(m,l,o,n){return o*(0.5-Math.cos(((m/n)*Math.PI))/2)+l;},QUAD_EASEIN:function(m,l,o,n){return o*(m/=n)*m+l;},QUAD_EASEOUT:function(m,l,o,n){return -o*(m/=n)*(m-2)+l;
},QUAD_EASEINOUT:function(m,l,o,n){if((m/=n/2)<1){return o/2*m*m+l;}return -o/2*((--m)*(m-2)-1)+l;},CUBIC_EASEIN:function(m,l,o,n){return o*(m/=n)*m*m+l;
},CUBIC_EASEOUT:function(m,l,o,n){return o*((m=m/n-1)*m*m+1)+l;},CUBIC_EASEINOUT:function(m,l,o,n){if((m/=n/2)<1){return o/2*m*m*m+l;}return o/2*((m-=2)*m*m+2)+l;
},QUART_EASEIN:function(m,l,o,n){return o*(m/=n)*m*m*m+l;},QUART_EASEOUT:function(m,l,o,n){return -o*((m=m/n-1)*m*m*m-1)+l;},QUART_EASEINOUT:function(m,l,o,n){if((m/=n/2)<1){return o/2*m*m*m*m+l;
}return -o/2*((m-=2)*m*m*m-2)+l;},QUINT_EASEIN:function(m,l,o,n){return o*(m/=n)*m*m*m*m+l;},QUINT_EASEOUT:function(m,l,o,n){return o*((m=m/n-1)*m*m*m*m+1)+l;
},QUINT_EASEINOUT:function(m,l,o,n){if((m/=n/2)<1){return o/2*m*m*m*m*m+l;}return o/2*((m-=2)*m*m*m*m+2)+l;},SIN_EASEIN:function(m,l,o,n){return -o*Math.cos(m/n*(Math.PI/2))+o+l;
},SIN_EASEOUT:function(m,l,o,n){return o*Math.sin(m/n*(Math.PI/2))+l;},SIN_EASEINOUT:function(m,l,o,n){return -o/2*(Math.cos(Math.PI*m/n)-1)+l;},CIRC_EASEIN:function(m,l,o,n){return -o*(Math.sqrt(1-(m/=n)*m)-1)+l;
},CIRC_EASEOUT:function(m,l,o,n){return o*Math.sqrt(1-(m=m/n-1)*m)+l;},CIRC_EASEINOUT:function(m,l,o,n){if((m/=n/2)<1){return -o/2*(Math.sqrt(1-m*m)-1)+l;
}return o/2*(Math.sqrt(1-(m-=2)*m)+1)+l;},ELASTIC_EASEIN:function(n,l,u,r,m,q){if(n===0){return l;}if((n/=r)===1){return l+u;}if(!q){q=r*0.3;}var o;if(!m||m<Math.abs(u)){m=u;
o=q/4;}else{o=q/(2*Math.PI)*Math.asin(u/m);}return -(m*Math.pow(2,10*(n-=1))*Math.sin((n*r-o)*(2*Math.PI)/q))+l;},ELASTIC_EASEOUT:function(n,l,u,r,m,q){if(n===0){return l;
}if((n/=r)===1){return l+u;}if(!q){q=r*0.3;}var o;if(!m||m<Math.abs(u)){m=u;o=q/4;}else{o=q/(2*Math.PI)*Math.asin(u/m);}return(m*Math.pow(2,-10*n)*Math.sin((n*r-o)*(2*Math.PI)/q)+u+l);
},ELASTIC_EASEINOUT:function(n,l,u,r,m,q){if(n===0){return l;}if((n/=r/2)===2){return l+u;}if(!q){q=r*(0.3*1.5);}var o;if(!m||m<Math.abs(u)){m=u;o=q/4;
}else{o=q/(2*Math.PI)*Math.asin(u/m);}if(n<1){return -0.5*(m*Math.pow(2,10*(n-=1))*Math.sin((n*r-o)*(2*Math.PI)/q))+l;}return m*Math.pow(2,-10*(n-=1))*Math.sin((n*r-o)*(2*Math.PI)/q)*0.5+u+l;
},BOUNCE_EASEOUT:function(m,l,o,n){if((m/=n)<(1/2.75)){return o*(7.5625*m*m)+l;}else{if(m<(2/2.75)){return o*(7.5625*(m-=(1.5/2.75))*m+0.75)+l;}else{if(m<(2.5/2.75)){return o*(7.5625*(m-=(2.25/2.75))*m+0.9375)+l;
}else{return o*(7.5625*(m-=(2.625/2.75))*m+0.984375)+l;}}}},BOUNCE_EASEIN:function(m,l,o,n){return o-g.Easing.BOUNCE_EASEOUT(n-m,0,o,n)+l;},BOUNCE_EASEINOUT:function(m,l,o,n){if(m<n/2){return g.Easing.BOUNCE_EASEIN(m*2,0,o,n)*0.5+l;
}else{return g.Easing.BOUNCE_EASEOUT(m*2-n,0,o,n)*0.5+o*0.5+l;}},BACK_EASEIN:function(m,l,p,o,n){if(n===c){n=1.70158;}return p*(m/=o)*m*((n+1)*m-n)+l;},BACK_EASEOUT:function(m,l,p,o,n){if(n===c){n=1.70158;
}return p*((m=m/o-1)*m*((n+1)*m+n)+1)+l;},BACK_EASEINOUT:function(m,l,p,o,n){if(n===c){n=1.70158;}if((m/=o/2)<1){return p/2*(m*m*(((n*=(1.525))+1)*m-n))+l;
}return p/2*((m-=2)*m*(((n*=(1.525))+1)*m+n)+2)+l;},EXPO_EASEIN:function(m,l,o,n){return(m===0)?l:o*Math.pow(2,10*(m/n-1))+l;},EXPO_EASEOUT:function(m,l,o,n){return(m===n)?l+o:o*(-Math.pow(2,-10*m/n)+1)+l;
},EXPO_EASEINOUT:function(m,l,o,n){if(m===0){return l;}if(m===n){return l+o;}if((m/=n/2)<1){return o/2*Math.pow(2,10*(m-1))+l;}return o/2*(-Math.pow(2,-10*--m)+2)+l;
}};g.ActionEventTarget=g.Class.create(g.EventTarget,{initialize:function(){g.EventTarget.apply(this,arguments);},dispatchEvent:function(p){var o=this.node?this.node:this;
p.target=o;p.localX=p.x-o._offsetX;p.localY=p.y-o._offsetY;if(this["on"+p.type]!=null){this["on"+p.type].call(o,p);}var n=this._listeners[p.type];if(n!=null){n=n.slice();
for(var m=0,l=n.length;m<l;m++){n[m].call(o,p);}}}});g.Timeline=g.Class.create(g.EventTarget,{initialize:function(m){g.EventTarget.call(this);this.node=m;
this.queue=[];this.paused=false;this.looped=false;this.isFrameBased=true;this._parallel=null;this._activated=false;this.addEventListener(g.Event.ENTER_FRAME,this._onenterframe);
var l=this;this._nodeEventListener=function(n){l.dispatchEvent(n);};},_deactivateTimeline:function(){if(this._activated){this._activated=false;this.node.removeEventListener("enterframe",this._nodeEventListener);
}},_activateTimeline:function(){if(!this._activated&&!this.paused){this.node.addEventListener("enterframe",this._nodeEventListener);this._activated=true;
}},_onenterframe:function(l){if(this.paused){return;}this.tick(this.isFrameBased?1:l.elapsed);},setFrameBased:function(){this.isFrameBased=true;},setTimeBased:function(){this.isFrameBased=false;
},next:function(l){var o,n=this.queue.shift();if(n){o=new g.Event("actionend");o.timeline=this;n.dispatchEvent(o);o=new g.Event("removedfromtimeline");
o.timeline=this;n.dispatchEvent(o);if(this.looped){this.add(n);}}if(this.queue.length===0){this._deactivateTimeline();return;}if(l>0||(this.queue[0]&&this.queue[0].time===0)){var m=new g.Event("actiontick");
m.elapsed=l;m.timeline=this;this.queue[0].dispatchEvent(m);}},tick:function(l){if(this.queue.length>0){var n=this.queue[0];if(n.frame===0){var m;m=new g.Event("actionstart");
m.timeline=this;n.dispatchEvent(m);}var o=new g.Event("actiontick");o.timeline=this;o.elapsed=l;n.dispatchEvent(o);}},add:function(l){this._activateTimeline();
if(this._parallel){this._parallel.actions.push(l);this._parallel=null;}else{this.queue.push(l);}l.frame=0;var m=new g.Event("addedtotimeline");m.timeline=this;
l.dispatchEvent(m);m=new g.Event("actionadded");m.action=l;this.dispatchEvent(m);return this;},action:function(l){return this.add(new g.Action(l));},tween:function(l){return this.add(new g.Tween(l));
},clear:function(){var n=new g.Event("removedfromtimeline");n.timeline=this;for(var m=0,l=this.queue.length;m<l;m++){this.queue[m].dispatchEvent(n);}this.queue=[];
this._deactivateTimeline();return this;},skip:function(m){var l=new g.Event("enterframe");if(this.isFrameBased){l.elapsed=1;}else{l.elapsed=m;m=1;}while(m--){this.dispatchEvent(l);
}return this;},pause:function(){if(!this.paused){this.paused=true;this._deactivateTimeline();}return this;},resume:function(){if(this.paused){this.paused=false;
this._activateTimeline();}return this;},loop:function(){this.looped=true;return this;},unloop:function(){this.looped=false;return this;},delay:function(l){return this.action({time:l});
},wait:function(l){return this;},then:function(l){return this.action({onactiontick:function(m){l.call(this);},time:0});},exec:function(l){return this.then(l);
},cue:function(l){var n=0;for(var m in l){if(l.hasOwnProperty(m)){this.delay(m-n);this.then(l[m]);n=m;}}return this;},repeat:function(l,m){return this.action({onactiontick:function(n){l.call(this);
},time:m});},and:function(){var m=this.queue.pop();if(m instanceof g.ParallelAction){this._parallel=m;this.queue.push(m);}else{var l=new g.ParallelAction();
l.actions.push(m);this.queue.push(l);this._parallel=l;}return this;},or:function(){return this;},doAll:function(l){return this;},waitAll:function(){return this;
},waitUntil:function(l){return this.action({onactiontick:function(m){if(l.call(this)){m.timeline.next();}}});},fadeTo:function(l,m,n){return this.tween({opacity:l,time:m,easing:n});
},fadeIn:function(l,m){return this.fadeTo(1,l,m);},fadeOut:function(l,m){return this.fadeTo(0,l,m);},moveTo:function(l,o,m,n){return this.tween({x:l,y:o,time:m,easing:n});
},moveX:function(l,m,n){return this.tween({x:l,time:m,easing:n});},moveY:function(n,l,m){return this.tween({y:n,time:l,easing:m});},moveBy:function(l,o,m,n){return this.tween({x:function(){return this.x+l;
},y:function(){return this.y+o;},time:m,easing:n});},hide:function(){return this.then(function(){this.opacity=0;});},show:function(){return this.then(function(){this.opacity=1;
});},removeFromScene:function(){return this.then(function(){this.parentNode.removeChild(this);});},scaleTo:function(o,n,p){var m,l;if(typeof p==="number"){m=arguments[0];
l=arguments[1];n=arguments[2];p=arguments[3];}else{m=l=o;}return this.tween({scaleX:m,scaleY:l,time:n,easing:p});},scaleBy:function(o,n,p){var m,l;if(typeof p==="number"){m=arguments[0];
l=arguments[1];n=arguments[2];p=arguments[3];}else{m=l=o;}return this.tween({scaleX:function(){return this.scaleX*m;},scaleY:function(){return this.scaleY*l;
},time:n,easing:p});},rotateTo:function(l,m,n){return this.tween({rotation:l,time:m,easing:n});},rotateBy:function(l,m,n){return this.tween({rotation:function(){return this.rotation+l;
},time:m,easing:n});}});g.Action=g.Class.create(g.ActionEventTarget,{initialize:function(n){g.ActionEventTarget.call(this);this.time=null;this.frame=0;
for(var l in n){if(n.hasOwnProperty(l)){if(n[l]!=null){this[l]=n[l];}}}var m=this;this.timeline=null;this.node=null;this.addEventListener(g.Event.ADDED_TO_TIMELINE,function(o){m.timeline=o.timeline;
m.node=o.timeline.node;m.frame=0;});this.addEventListener(g.Event.REMOVED_FROM_TIMELINE,function(){m.timeline=null;m.node=null;m.frame=0;});this.addEventListener(g.Event.ACTION_TICK,function(o){var p=m.time-(m.frame+o.elapsed);
if(m.time!=null&&p<=0){m.frame=m.time;o.timeline.next(-p);}else{m.frame+=o.elapsed;}});}});g.ParallelAction=g.Class.create(g.Action,{initialize:function(m){g.Action.call(this,m);
this.actions=[];this.endedActions=[];var l=this;this.addEventListener(g.Event.ACTION_START,function(o){for(var p=0,n=l.actions.length;p<n;p++){l.actions[p].dispatchEvent(o);
}});this.addEventListener(g.Event.ACTION_TICK,function(o){var p,n,q={next:function(s){var t=l.actions[p];l.actions.splice(p--,1);n=l.actions.length;l.endedActions.push(t);
var u=new g.Event("actionend");u.timeline=this;t.dispatchEvent(u);u=new g.Event("removedfromtimeline");u.timeline=this;t.dispatchEvent(u);}};var r=new g.Event("actiontick");
r.timeline=q;r.elapsed=o.elapsed;for(p=0,n=l.actions.length;p<n;p++){l.actions[p].dispatchEvent(r);}if(l.actions.length===0){o.timeline.next();}});this.addEventListener(g.Event.ADDED_TO_TIMELINE,function(o){for(var p=0,n=l.actions.length;
p<n;p++){l.actions[p].dispatchEvent(o);}});this.addEventListener(g.Event.REMOVED_FROM_TIMELINE,function(){l.actions=l.endedActions;l.endedActions=[];});
}});g.Tween=g.Class.create(g.Action,{initialize:function(o){var l={};var n={};g.Action.call(this,o);if(this.easing==null){this.easing=g.Easing.LINEAR;}var m=this;
this.addEventListener(g.Event.ACTION_START,function(){var p=["frame","time","callback","onactiontick","onactionstart","onactionend"];for(var r in o){if(o.hasOwnProperty(r)){var q;
if(typeof o[r]==="function"){q=o[r].call(m.node);}else{q=o[r];}if(p.indexOf(r)===-1){l[r]=m.node[r];n[r]=q;}}}});this.addEventListener(g.Event.ACTION_TICK,function(p){var q=m.time===0?1:m.easing(Math.min(m.time,m.frame+p.elapsed),0,1,m.time)-m.easing(m.frame,0,1,m.time);
for(var r in n){if(n.hasOwnProperty(r)){if(typeof this[r]==="undefined"){continue;}m.node[r]+=(n[r]-l[r])*q;if(Math.abs(m.node[r])<1e-7){m.node[r]=0;}}}});
}});}(window));